#!/bin/sh

# Find out where the script is located

if [ -e /bin/sed -a -x /bin/sed ]
then
    SCRIPT_BASE=$(echo $0 | sed s/autoboot.sh//)
else
    for i in 1 2 3 4 5 6 7 8 9; do
	FIELD=$(echo $0 | cut -d / -f $i)
	if [ "$FIELD" = "autoboot.sh" ]
	then
	    i=$[$i-1]
	    SCRIPT_BASE=$(echo $0 | cut -d / -f -$i)/
	    break
	fi
    done
fi


cd $SCRIPT_BASE

# Make path absolute

SCRIPT_BASE=$(pwd)

. ./scripts/boot_functions

# Read in fancy output functions
. ./scripts/output.sh

export PATH=$PATH:$BINARY_PATH

# Turn on backlight

/usr/bin/fbpwm -b 1 -i 75

##############################################################################

if test -e $FILE_PATH/$ROOT_FILE; 
then
	for i in $MODULES;
	do
		modprobe $i
		test_failure
	done

fi

##############################################################################

if [ ! -e $MOUNT_POINT ]
then
	mount none / -o remount
	test_failure
	mkdir $MOUNT_POINT
	test_failure
fi
mount $MOUNT_OPTS $ROOT_MOUNT_DEV $MOUNT_POINT



##############################################################################

if [ -e $MOUNT_POINT/lib/modules -a -e $MOUNT_POINT/sbin/depmod ]
then
	begin_operation "Run depmod"
	$MOUNT_POINT/sbin/depmod -q -b $MOUNT_POINT
	test_result
fi

##############################################################################

umount $MOUNT_POINT

##############################################################################

# Rev A Terminal compatibility check

ERROR=$(dmesg | grep hwblock | grep failure)

echo $ERROR

if [ "$ERROR" != "" ]; then
   mit_echo "Not Safe to Install AutoFarm Software"
   mit_echo "Contact your Sales Representative"

   mit_echo ""
   mit_echo "Powering off in 20 seconds"

   sleep 20
   poweroff

fi 

##############################################################################

/mnt/sandisk/upgrade/apps/softwareupgrade/startSu.sh

