##############################################################################
#
# vc/src/tcl/setup.tcl
#
# AutoFarm Setup screen
#
# 20021024 QC - created
#
# Copyright (c) 2002 IntegriNautics Corporation.
# All Rights Reserved. 
##############################################################################
namespace eval Screen { 

    #-------------------------------------------------------------------------
    # Define and pack the screen
    #-------------------------------------------------------------------------
    # All screens must create a top level frame .ftop and destroy it in sExit
    frame .ftop

    # Title
    label .ftop.title -text "AutoSteer Setup Summary" -font $huge_font
    pack .ftop.title -side top

    # Field, Job, Implement etc.
    frame .ftop.disp1

    # Left side
    frame .ftop.disp1.l

    frame .ftop.disp1.l.r1
    label .ftop.disp1.l.r1.l -text "Field:" -font $medium_font
    label .ftop.disp1.l.r1.e -text "foo" -font $medium_font 
    pack .ftop.disp1.l.r1.l -side left
    pack .ftop.disp1.l.r1.e -side right

    frame .ftop.disp1.l.r2
    label .ftop.disp1.l.r2.l -text "Job:" -font $medium_font
    label .ftop.disp1.l.r2.e -text "foo" -font $medium_font 
    pack .ftop.disp1.l.r2.l -side left
    pack .ftop.disp1.l.r2.e -side right

    frame .ftop.disp1.l.r3
    label .ftop.disp1.l.r3.l -text "Tractor" -font $medium_font
    label .ftop.disp1.l.r3.e -text "foo" -font $medium_font 
    pack .ftop.disp1.l.r3.l -side left
    pack .ftop.disp1.l.r3.e -side right

    frame .ftop.disp1.l.r4
    label .ftop.disp1.l.r4.l -text "Base:" -font $medium_font
    label .ftop.disp1.l.r4.e -text "foo" -font $medium_font 
    pack .ftop.disp1.l.r4.l -side left
    pack .ftop.disp1.l.r4.e -side right

    # Right side
    frame .ftop.disp1.r
    
    frame .ftop.disp1.r.r1
    label .ftop.disp1.r.r1.l -text "Implement:" -font $medium_font
    label .ftop.disp1.r.r1.e -text "bar" -font $medium_font 
    pack .ftop.disp1.r.r1.l -side left
    pack .ftop.disp1.r.r1.e -side right

    frame .ftop.disp1.r.r2
    label .ftop.disp1.r.r2.l -text "Type:" -font $medium_font
    label .ftop.disp1.r.r2.e -text "Hitched" -font $medium_font 
    pack .ftop.disp1.r.r2.l -side left
    pack .ftop.disp1.r.r2.e -side right

    frame .ftop.disp1.r.r3
    label .ftop.disp1.r.r3.l -text "Width:" -font $medium_font
    label .ftop.disp1.r.r3.e -text "xx feet" -font $medium_font 
    pack .ftop.disp1.r.r3.l -side left
    pack .ftop.disp1.r.r3.e -side right
    
    frame .ftop.disp1.r.r4
    label .ftop.disp1.r.r4.l -text "Offset:" -font $medium_font
    label .ftop.disp1.r.r4.e -text "xx feet" -font $medium_font 
    pack .ftop.disp1.r.r4.l -side left
    pack .ftop.disp1.r.r4.e -side right

    # Pack .ftop.disp1
    pack .ftop.disp1.l.r1 -side top -anchor w -fill x -expand yes
    pack .ftop.disp1.l.r2 -side top -anchor w -fill x -expand yes
    pack .ftop.disp1.l.r3 -side top -anchor w -fill x -expand yes
    pack .ftop.disp1.l.r4 -side top -anchor w -fill x -expand yes

    pack .ftop.disp1.r.r1 -side top -anchor w -fill x -expand yes
    pack .ftop.disp1.r.r2 -side top -anchor w -fill x -expand yes
    pack .ftop.disp1.r.r3 -side top -anchor w -fill x -expand yes
    pack .ftop.disp1.r.r4 -side top -anchor w -fill x -expand yes

    pack .ftop.disp1.l -side left -padx 20 -fill x -expand yes
    pack .ftop.disp1.r -side left -padx 20 -fill x -expand yes

    # AutoFarm hours and acres
    frame .ftop.disp2

    # Row 5
    frame .ftop.disp2.r5
    
    frame .ftop.disp2.r5.c1
    label .ftop.disp2.r5.c1.l -text "AutoSteer Hours:" -font $medium_font
    label .ftop.disp2.r5.c1.e -text "xx" -font $medium_font \
                  -width 11 -anchor e -relief sunken -borderwidth 2
    pack .ftop.disp2.r5.c1.l -side left -pady 1
    pack .ftop.disp2.r5.c1.e -side left -pady 1
    
    frame .ftop.disp2.r5.c2
    label .ftop.disp2.r5.c2.l -text "Since Last Reset:" -font $medium_font
    label .ftop.disp2.r5.c2.e -text "bar" -font $medium_font \
                  -width 11 -anchor e -relief sunken -borderwidth 2

    SnazzyButton::create .ftop.disp2.r5.c2.b btnBlueM6U btnBlueM6D 0.5 \
                         "beepOnce; post $DISP_BTN1_SIG 0" "Reset"    
    pack .ftop.disp2.r5.c2.l -side left -pady 1
    pack .ftop.disp2.r5.c2.e -side left -pady 1
    pack .ftop.disp2.r5.c2.b -side left -padx 7 -pady 1 

    pack .ftop.disp2.r5.c1 -side left
    pack .ftop.disp2.r5.c2 -side right

    # Row 6
    frame .ftop.disp2.r6
    
    frame .ftop.disp2.r6.c1
    label .ftop.disp2.r6.c1.l -text "AutoSteer Acres:" -font $medium_font
    label .ftop.disp2.r6.c1.e -text "xx" -font $medium_font \
                  -width 11 -anchor e -relief sunken -borderwidth 2
    pack .ftop.disp2.r6.c1.l -side left -pady 1
    pack .ftop.disp2.r6.c1.e -side left -pady 1
    
    frame .ftop.disp2.r6.c2
    label .ftop.disp2.r6.c2.l -text "Since Last Reset:" -font $medium_font
    label .ftop.disp2.r6.c2.e -text "bar" -font $medium_font \
                  -width 11 -anchor e -relief sunken -borderwidth 2
                  
    SnazzyButton::create .ftop.disp2.r6.c2.b btnBlueM6U btnBlueM6D 0.5 \
                         "beepOnce; post $DISP_BTN1_SIG 1" "Reset"                  
    pack .ftop.disp2.r6.c2.l -side left -pady 1
    pack .ftop.disp2.r6.c2.e -side left -pady 1
    pack .ftop.disp2.r6.c2.b -side left -padx 7 -pady 1

    pack .ftop.disp2.r6.c1 -side left
    pack .ftop.disp2.r6.c2 -side right

    # Pack rows
    pack .ftop.disp2.r5 -side top -anchor w -padx 20 -fill x
    pack .ftop.disp2.r6 -side top -anchor w -padx 20 -fill x

    # Response Rate Sliders
    frame .ftop.sliders
    frame .ftop.sliders.r1
    pack .s2 -in .ftop.sliders.r1 -side top
    raise .s2
    frame .ftop.sliders.r2
    pack .s1 -in .ftop.sliders.r2 -side top
    raise .s1
    pack .ftop.sliders.r1 -side top -pady 5
    pack .ftop.sliders.r2 -side top -pady 5
    
    # Cancel/Accept frame
    frame .ftop.acceptReject
    SnazzyButton::create .ftop.acceptReject.cancel btnKhakiU btnKhakiD 0.5 \
         "beepOnce; post $DISP_BTN9_SIG 9;" "Return To\nManual\nSteering"    
    SnazzyButton::create .ftop.acceptReject.accept btnBlueU btnBlueD 0.5 \
         "beepOnce; post $DISP_BTN3_SIG 3;" "Adjust\nGuess\nRow"
    pack .ftop.acceptReject.cancel -side left -padx 10 -pady 10
    pack .ftop.acceptReject.accept -side left -padx 10 -pady 10

    # Pack rows
    pack .ftop.disp1 -side top -pady 10 -fill x -expand yes
    pack .ftop.disp2 -side top -pady 10 -fill x -expand yes
    pack .ftop.acceptReject -side left -anchor sw -padx 10
    pack .ftop.sliders -side right -anchor e -padx 10 -pady 10 \
            -fill both -expand yes

    #-------------------------------------------------------------------------
    # Standard entry and exit procedures (called by GuiMgr)
    #-------------------------------------------------------------------------
    # Action called by GuiMgr on entry to this screen
    proc actEntry { fieldLbl field jobLbl job tractorLbl tractor baseLbl \
         base implementLbl typeLbl widthLbl offsetLbl titleLbl \
         resetBtn returnBtn adjustBtn } {
        .ftop.disp1.l.r1.l configure -text $fieldLbl
        .ftop.disp1.l.r1.e configure -text $field
        .ftop.disp1.l.r2.l configure -text $jobLbl
        .ftop.disp1.l.r2.e configure -text $job
        .ftop.disp1.l.r3.l configure -text $tractorLbl
        .ftop.disp1.l.r3.e configure -text $tractor
        .ftop.disp1.l.r4.l configure -text $baseLbl
        .ftop.disp1.l.r4.e configure -text $base
 
        .ftop.disp1.r.r1.l configure -text $implementLbl
        .ftop.disp1.r.r2.l configure -text $typeLbl 
        .ftop.disp1.r.r3.l configure -text $widthLbl
        .ftop.disp1.r.r4.l configure -text $offsetLbl
        .ftop.title configure -text $titleLbl

        SnazzyButton::setText .ftop.disp2.r5.c2.b $resetBtn 0.5      
        SnazzyButton::setText .ftop.disp2.r6.c2.b $resetBtn 0.5        
        SnazzyButton::setText .ftop.acceptReject.cancel $returnBtn 0.5
        SnazzyButton::setText .ftop.acceptReject.accept $adjustBtn 0.5        
         
        pack .ftop -fill both -expand yes
    }
    
    # Action called by GuiMgr on exit from this screen
    proc actExit {} {

        destroy .ftop

    }


    #-------------------------------------------------------------------------
    # Screen action procedures (to be called by GuiMgr)
    #-------------------------------------------------------------------------
    # Update procedures of this template can be called by the GuiMgr

    proc actSliderValue { sliderNum val notch } {
        Sliders::sliderSetValue .s$sliderNum $val $notch
    }

    proc actImplement { name type width offset } {
        .ftop.disp1.r.r1.e configure -text $name
        .ftop.disp1.r.r2.e configure -text $type
        .ftop.disp1.r.r3.e configure -text $width
        .ftop.disp1.r.r4.e configure -text $offset
    }

    proc actHoursAcres { autofarmhoursLbl autofarmacresLbl sinceLbl \
            hours acres hoursincelastreset acresincelastreset } {
        .ftop.disp2.r5.c1.l configure -text $autofarmhoursLbl
        .ftop.disp2.r5.c2.l configure -text $sinceLbl
        .ftop.disp2.r6.c1.l configure -text $autofarmacresLbl
        .ftop.disp2.r6.c2.l configure -text $sinceLbl
        .ftop.disp2.r5.c1.e configure -text $hours
        .ftop.disp2.r6.c1.e configure -text $acres
        .ftop.disp2.r5.c2.e configure -text $hoursincelastreset
        .ftop.disp2.r6.c2.e configure -text $acresincelastreset
    }


    #-------------------------------------------------------------------------
    # Local procedures
    #-------------------------------------------------------------------------
    proc ToBeCompleted {} {

    }

}
