##############################################################################
#
# vc/src/tcl/surveyAtt.tcl
#
# Screen to display details about Position examination.
#
# 20030421 M_S - created
#
# Copyright (c) 2002-2003 IntegriNautics Corporation.
# All Rights Reserved. 
##############################################################################
namespace eval Screen { 

    #-------------------------------------------------------------------------
    # Define and pack the screen
    #-------------------------------------------------------------------------
    # All screens must create a top level frame .ftop and destroy it on exit
    frame .ftop

    # NOTE: using place for positioning imported frames (-in option)
    #       craches Tcl interpreter. Therefore pack must be used.
    pack .configDisplay -in .ftop -side left \
            -anchor n -padx 10 -pady 10
    raise .configDisplay
    pack .navDisplay -in .ftop -side right -anchor n -padx 10 -pady 10
    raise .navDisplay


    # title and error indicator
    label .ftop.title -font $huge_font
    place .ftop.title -relx 0.5 -rely 0.3 -anchor n
    
    # labels
    label .ftop.b1Lbl -text "B1:" -font $big_font
    place .ftop.b1Lbl -relx 0.25 -x 60 -rely 0.5 -anchor ne
    label .ftop.b2Lbl -text "B2:" -font $big_font
    place .ftop.b2Lbl -relx 0.25 -x 60 -rely 0.5 -y 40 -anchor ne
       
    label .ftop.b1 -font $big_font -width 25 -relief sunken -borderwidth 2 
    place .ftop.b1 -relx 0.25 -x  80 -rely 0.5 -anchor nw
    label .ftop.b2 -font $big_font -width 25 -relief sunken -borderwidth 2 
    place .ftop.b2 -relx 0.25 -x  80 -rely 0.5 -y 40 -anchor nw
   
    label .ftop.tLbl -text "t:" -font $big_font
    place .ftop.tLbl -relx 0.25 -x 60 -rely 0.7 -anchor ne
    label .ftop.t -font $big_font -width 10 -relief sunken -borderwidth 2 
    place .ftop.t -relx 0.25 -x 80 -rely 0.7 -anchor nw
    
    # buttons
    button .ftop.exit -width 10 -height 6 \
            -command {beepOnce; post $DISP_BTN9_SIG 9 } \
            -background $color5 -activebackground $color5
    place .ftop.exit -x 10 -rely 1.0 -y -10 -anchor sw            

    #-------------------------------------------------------------------------
    # Standard entry and exit procedures (called by GuiMgr)
    #-------------------------------------------------------------------------
    # Action called by GuiMgr on entry to this screen
    
    proc actEntry { titleLbl returnToPreviousMenuBtn } {
        .ftop.title configure -text $titleLbl
        .ftop.exit configure -text $returnToPreviousMenuBtn
        pack .ftop -fill both -expand yes
    }

    # Action called by GuiMgr on exit from this screen
    proc actExit {} {
        destroy .ftop
    }

    #-------------------------------------------------------------------------
    # other action procedures (called by GuiMgr)
    #-------------------------------------------------------------------------

    proc actDisplaySurveyProgress { bl1 mbl1 bl2 mbl2 t } {
        .ftop.b1  configure -text "$bl1/$mbl1"
        .ftop.b2  configure -text "$bl2/$mbl2"
        .ftop.t   configure -text $t
    }
    
    proc actDisplaySurveyDone { titleLbl } {
        .ftop.title configure -text $titleLbl
        place forget .ftop.b1Lbl
        place forget .ftop.b2Lbl
        place forget .ftop.tLbl
        place forget .ftop.b1
        place forget .ftop.b2
        place forget .ftop.t
    }
}
