#!/bin/sh

# This script launches software select (SS).  It then goes into a polling
# loop, looking for a flag file.  The flag file indicates which app to
# launch.  When the app is launched, the script exits.  The reason this
# script is here is because the SS app itself could not consistently
# launch applications.
# Randy, Dec '05.

# Hack warning - modified this code to also handle the copying of the
# AfViewer file to external flash.   It looks for the flag file
# (copyAfViewer) and copies the AfViewer if this file is found. 

umount /data

# check every second
CHECK_INTERVAL=1

export TCL_LIBRARY=/lib/tcl8.4
export TK_LIBRARY=/lib/tk8.4
export DISPLAY=:0.0

# start software select
cd /mnt/apps/softwareselect/bin
./eldkdebug1_1t/softwareselect  &


# remove flag files
/bin/rm /tmp/launchSim
/bin/rm /tmp/launchAl
/bin/rm /tmp/launchVc

###############################################################################
# Polling loop
###############################################################################

while true; do

    if [ -e /tmp/launchSim ]; then
       /mnt/apps/vc/startSim
       /bin/rm /tmp/launchSim
    fi

    if [ -e /tmp/launchAl ]; then
       /mnt/apps/al/startAl
       /bin/rm /tmp/launchAl
    fi

    if [ -e /tmp/launchVc ]; then
       /mnt/apps/vc/startVc
       /bin/rm /tmp/launchVc
    fi

    # this is a dirty hack to get the afviewer on the external compact flash
    if [ -e /tmp/copyAfViewer ]; then
       /mnt/apps/afviewer/exportViewer.sh
       exit
    fi

    sleep $CHECK_INTERVAL

done
