#!/bin/sh

# ExportFiles is part of the postmortum application.  It copies all files
# from /data/currdir to the external flash

# delete all the flag files
/bin/rm /tmp/noExternalFlash
/bin/rm /tmp/exportComplete
/bin/rm /tmp/exportFailed

# Is the external flash mounted?
#   unmount the flash (will fail is not mounted, but no biggie)
umount /mntd

# Now, mount the flash and check for success
/bin/mount -t vfat /dev/hda1 /mntd
if [ $? -ne 0 ]; then    # not mounted
   touch /tmp/noExternalFlash
   exit;
fi

# get db compare change files
# don't file if copy did not work for some reason
/bin/mount -t jffs2 /dev/mtdblock4 /configuration/currdir0
cd /configuration/currdir0
cp *.ctrlchg /mntd
cd /
/bin/umount /configuration/currdir0

# mount /data/currdir
#   if already mounted, no problem
/bin/mount -t jffs2 /dev/mtdblock6 /data

# /data/currdir found, and external disk found

cp /data/currdir/* /mntd
if [ $? -eq 0 ]; then
   touch /tmp/exportComplete;
else
   touch /tmp/exportFailed;
fi

umount /dev/hda1

