##############################################################################
#
# sync/src/tcl/selectbase.tcl
#
# Screen to display selectbase selections
#
# RA - created
#
# Copyright (c) 2005 Novariant Corporation.
# All Rights Reserved. 
##############################################################################
namespace eval Screen { 
    frame .ftop

    frame .ftop.title
    pack .ftop.title -side top

    label .ftop.title.title -font $huge_font -width 45 \
	-text "Updating Current Configuration" -pady 10

    pack .ftop.title.title -side left

    image create photo btnBlueQuestionU -format gif -file \
	${tclPath}gif/btnBlueQuestionU.gif
    image create photo btnBlueQuestionD -format gif -file \
	${tclPath}gif/btnBlueQuestionD.gif

    SnazzyButton::create .ftop.title.help btnBlueQuestionU btnBlueQuestionD 0.5 \
	"beepOnce; post $DISP_BTN0_SIG 0" ""

    pack .ftop.title.help -side right -ipadx 10 -ipady 5

    label .ftop.attention -font $big_font -pady 7
    pack .ftop.attention -side top

    frame .ftop.conflict
    pack .ftop.conflict -side top

    scrollbar .ftop.conflict.sbar -orient vertical \
	-command [list .ftop.conflict.localTxt yview] \
	-width 36

    listbox .ftop.conflict.localTxt -width 80 -height 12 -font $small_font \
	-exportselection 0 \
	-yscrollcommand [list .ftop.conflict.sbar set] \
	-background white -selectbackground gray

    pack .ftop.conflict.sbar -side right -fill y
    pack .ftop.conflict.localTxt -side right

    frame .ftop.buttons
    pack .ftop.buttons -side top -fill x

    SnazzyButton::create .ftop.buttons.yes btnAcceptU btnAcceptD 0.3 \
	"beepOnce; post $DISP_BTN1_SIG 1" "Ok"

    pack .ftop.buttons.yes -side right -padx 15 -pady 5 -anchor se

    #-------------------------------------------------------------------------
    # Standard entry and exit procedures (called by GuiMgr)
    #-------------------------------------------------------------------------
    # Action called by GuiMgr on entry to this screen
    proc actEntry {type delname} {
	global huge_font color3

	.ftop.attention configure -text \
	    "Previous current $type $delname\nhas been deleted \
from your GPS System.\nPlease select a new current $type."
        pack .ftop -fill both -expand yes
    }


    # Action called by GuiMgr on exit from this screen
    proc actExit {} {
        destroy .ftop
        pack .ftop -fill both -expand yes
    }

    #-------------------------------------------------------------------------
    # Screen action procedures (to be called by GuiMgr)
    #-------------------------------------------------------------------------

    proc actListboxInsert { item } {
	#puts "selectBase -- insert $item"
	.ftop.conflict.localTxt insert end $item
    }

    proc actListboxGetCurselection {} {
	if { [.ftop.conflict.localTxt index end] != 0} {
	    set index [.ftop.conflict.localTxt curselection]
	    return [.ftop.conflict.localTxt get $index]
	} else {
	    return "!"             ;# ! tells the C side the listbox was empty
	}
    }

    proc actCopySuccess {typename entryname} {
    }

}
