##############################################################################
#
# vc/src/tcl/setimezone.tcl
#
# Screen to set time zone.
#
# 20040129 QC - created
#
# Copyright (c) 2002 IntegriNautics Corporation.
# All Rights Reserved. 
##############################################################################
namespace eval Screen { 

    #-------------------------------------------------------------------------
    # Define and pack the screen
    #-------------------------------------------------------------------------
    # All screens must create a top level frame .ftop and destroy it on exit
    frame .ftop

    # Define and pack the screen layout

    # Title
    label .ftop.title -text "Space for title" -font $huge_font
    
    # Input frame
    frame .ftop.input1
    frame .ftop.input1.l
    frame .ftop.input1.r
    frame .ftop.input1.r.r1
    frame .ftop.input1.r.r2
    frame .ftop.input2
    frame .ftop.input2.l
    frame .ftop.input2.r
    frame .ftop.input5
    
   
    SnazzyButton::create .ftop.input1.r.r1.disable_0Hz btnBlueM5U btnBlueM5D \
                  0.5 "beepOnce; post $DISP_BTN2_SIG 0;" "OFF" 
    SnazzyButton::create .ftop.input1.r.r1.enable_1Hz btnBlueM5U btnBlueM5D \
                  0.5 "beepOnce; post $DISP_BTN2_SIG 1;" "1"
    SnazzyButton::create .ftop.input1.r.r2.enable_5Hz btnBlueM5U btnBlueM5D \
                  0.5 "beepOnce; post $DISP_BTN2_SIG 5;" "5"
    #SnazzyButton::create .ftop.input1.r.r2.enable_10Hz btnBlueM5U btnBlueM5D \
    #              0.5 "beepOnce; post $DISP_BTN2_SIG 10;" "10" 
                  
    label .ftop.input2.l.supportedMsg -text "Supported Messages:" \
                                      -font $medium_font 
    label .ftop.input2.r.selectedNMEAMsg -text "Text For Selected NMEA Msg" \
                                         -width 4 -font $medium_font                                  
    label .ftop.input2.r.messagesPerSec -text "Messages Per Second:" \
                                        -width 20 -font $medium_font 
                                                             
    scrollbar .ftop.input1.l.sbar -command { .ftop.input1.l.lbox yview }
    listbox .ftop.input1.l.lbox -yscrollcommand {.ftop.input1.l.sbar set} \
          -width 16 -height 5
          
    #scrollbar .ftop.input5.sbar -command { .ftop.input5.lbox yview }
    text .ftop.input5.lbox -font $small_font -background white \
                           -width 92 -height 7
                   
    pack .ftop.input1.r.r1.enable_1Hz -side right
    pack .ftop.input1.r.r1.disable_0Hz -side right -padx 10
    #pack .ftop.input1.r.r2.enable_10Hz -side right 
    pack .ftop.input1.r.r2.enable_5Hz -side right -padx 10
    pack .ftop.input1.r.r1 -side top -padx 10
    pack .ftop.input1.r.r2 -side left -padx 10 -pady 10
    pack .ftop.input1.l.lbox -side left -pady 5 
    pack .ftop.input1.l.sbar -side left -pady 5 -fill y
    pack .ftop.input1.l -side left 
    pack .ftop.input1.r -side right -anchor se
     
    pack .ftop.input2.l.supportedMsg -padx 10
    pack .ftop.input2.r.messagesPerSec -side right
    pack .ftop.input2.r.selectedNMEAMsg -side right -padx 0     
    pack .ftop.input2.l -side left  
    pack .ftop.input2.r -side right -padx 130
      
    pack .ftop.input5.lbox -side left -pady 5 -fill y
    #pack .ftop.input5.sbar -side left -pady 5 -fill y
            
    # Return to previous menu, configure user ports frame / text
    frame .ftop.input3
    frame .ftop.input3.l
    frame .ftop.input3.r
    frame .ftop.input3.c
    frame .ftop.input3.c.r1
    frame .ftop.input3.c.r2
    frame .ftop.input3.c.r3
    
    SnazzyButton::create .ftop.input3.l.cancel btnKhakiU btnKhakiD 0.5 \
                 "beepOnce; post $DISP_BTN9_SIG 9;" "Return To Previous Menu"
    SnazzyButton::create .ftop.input3.r.configUsrPorts btnBlueU btnBlueD 0.5 \
                 "beepOnce; post $DISP_BTN3_SIG 3;" "Configure User Ports"                       
    
    label .ftop.input3.c.r1.title -text "Text For User Config" \
                                  -font $large_font 
    label .ftop.input3.c.r2.user1 -text "Text For User Port1 Config" \
                                  -font $medium_font
    label .ftop.input3.c.r2.status -text "Text For User Port1 Config" \
                                  -font $medium_font
    label .ftop.input3.c.r2.usr1Baud -text "Text For User Port1 Config" \
                                  -font $medium_font                                                             
    label .ftop.input3.c.r3.user2 -text "Text For User Port2 Config" \
                                  -font $medium_font
    label .ftop.input3.c.r3.status -text "Text For User Port1 Config" \
                                  -font $medium_font
    label .ftop.input3.c.r3.usr2Baud -text "Text For User Port1 Config" \
                                  -font $medium_font                                                                                    
    
    pack .ftop.input3.l.cancel 
    pack .ftop.input3.r.configUsrPorts -side right
    pack .ftop.input3.c.r1.title -side top -padx 0
   
    pack .ftop.input3.c.r2.user1 -side left  
    pack .ftop.input3.c.r2.status -side right 
    pack .ftop.input3.c.r2.usr1Baud -side left   
    pack .ftop.input3.c.r3.user2 -side left
    pack .ftop.input3.c.r3.status -side right    
    pack .ftop.input3.c.r3.usr2Baud -side left
    
    pack .ftop.input3.c.r1 -padx 60
    pack .ftop.input3.c.r2 -anchor w -padx 26 
    pack .ftop.input3.c.r3 -anchor sw -padx 26
    pack .ftop.input3.l -side left
    pack .ftop.input3.c -side left
    pack .ftop.input3.r -side right 
        
    # Pack .ftop
         
    pack .ftop.title -side top -pady 7
    pack .ftop.input3 -side bottom -anchor sw -fill x -padx 5 -pady 5
    pack .ftop.input5 -side bottom -anchor sw -padx 10
    pack .ftop.input2 -side top -anchor w
    pack .ftop.input1 -side left -anchor n -padx 10
             
    #-------------------------------------------------------------------------
    # Standard entry and exit procedures (called by GuiMgr)
    #-------------------------------------------------------------------------
    # Action called by GuiMgr on entry to this screen
    proc actEntry {titleLbl supportedMsgLbl msgPerSecLbl msgOffLbl portLbl \
                   configPortsBtn returnBtn porttitle } {
                 
      .ftop.title configure -text $titleLbl
      .ftop.input2.l.supportedMsg configure -text $supportedMsgLbl
      .ftop.input2.r.messagesPerSec configure -text $msgPerSecLbl
      .ftop.input1.r.r1.disable_0Hz configure -text $msgOffLbl
      .ftop.input3.c.r1.title configure -text $porttitle
      .ftop.input3.c.r2.user1 configure -text "${portLbl}1:"
      .ftop.input3.c.r2.status configure -text "Status"
      .ftop.input3.c.r2.usr1Baud configure -text "Baud Rate"      
      .ftop.input3.c.r3.user2 configure -text "${portLbl}2:"
      .ftop.input3.c.r3.status configure -text "Status"
      .ftop.input3.c.r3.usr2Baud configure -text "Baud Rate"
      
      SnazzyButton::setText .ftop.input3.l.cancel $returnBtn 0.5
      SnazzyButton::setText .ftop.input3.r.configUsrPorts $configPortsBtn 0.5
                 
      pack .ftop -fill both -expand yes
    }

    # Action called by GuiMgr on exit from this screen
    proc actExit {} {
        destroy .ftop
    }

    #-------------------------------------------------------------------------
    # Screen action procedures (to be called by GuiMgr)
    #-------------------------------------------------------------------------
      
      bind .ftop.input1.l.lbox <ButtonPress-1> {
        beepOnce; post $DISP_BTN1_SIG 1;  
      } 
      
      
      proc actListboxInsert { item__ } {
        .ftop.input1.l.lbox insert end $item__
        .ftop.input1.l.lbox selection set 0
      }
            
      proc actListboxGetCurindex {} {
        if { [.ftop.input1.l.lbox index end] != 0} {
            return [lindex [.ftop.input1.l.lbox curselection] 0]
        } else {
            return -1             ;# -1 tells the C side the listbox was empty
        }
      }
      
      proc actHighLightBtn0 {} {
        SnazzyButton::setImage .ftop.input1.r.r1.disable_0Hz \
        btnGreenM5U btnGreenM5D 0.5 
        
      }
      proc actHighLightBtn1 {} {
        SnazzyButton::setImage .ftop.input1.r.r1.enable_1Hz \
        btnGreenM5U btnGreenM5D 0.5 
        
      }
      proc actHighLightBtn5 {} {
        SnazzyButton::setImage .ftop.input1.r.r2.enable_5Hz \
        btnGreenM5U btnGreenM5D 0.5 
        
      }
      #proc actHighLightBtn10 {} {
        #SnazzyButton::setImage .ftop.input1.r.r2.enable_10Hz \
        #btnGreenM5U btnGreenM5D 0.5 
        
      #} 
      
      proc actDispSelMsg { NMEAStr__ } {
        .ftop.input2.r.selectedNMEAMsg configure -text $NMEAStr__
      }
      
      proc actUnHighLightAllBtns {} {
        SnazzyButton::setImage .ftop.input1.r.r1.disable_0Hz \
        btnBlueM5U btnBlueM5D 0.5
        
        SnazzyButton::setImage .ftop.input1.r.r1.enable_1Hz \
        btnBlueM5U btnBlueM5D 0.5 
        
        SnazzyButton::setImage .ftop.input1.r.r2.enable_5Hz \
        btnBlueM5U btnBlueM5D 0.5 
        
        #SnazzyButton::setImage .ftop.input1.r.r2.enable_10Hz \
        #btnBlueM5U btnBlueM5D 0.5 
      }  
      
      proc actDispNMEAMsg { Msg__ } {
        regsub -all {[\r]} $Msg__ "" newStr
        .ftop.input5.lbox insert 1.0 $newStr
      }
      
      proc actDispUsr1Config { status__ baud__ } {
        .ftop.input3.c.r2.status configure -text $status__
        .ftop.input3.c.r2.usr1Baud configure -text $baud__  
      } 
      
      proc actDispUsr2Config { status__ baud__ } {
        .ftop.input3.c.r3.status configure -text $status__
        .ftop.input3.c.r3.usr2Baud configure -text $baud__  
      }
                
      proc actListboxDeleteAll { } {
        .ftop.input1.l.lbox delete 0 end
      }
       
    #-------------------------------------------------------------------------
    # Delegated procedures
    #-------------------------------------------------------------------------

    #-------------------------------------------------------------------------
    # Local procedures
    # {MLE-020418: Tcl/Tk goal should be to get rid of all local procedures, 
    # because they represent intelligence, which the display should not have.}
    #-------------------------------------------------------------------------
    # Local procedures
}
