##############################################################################
#
# vc/src/tcl/configOmniStar.tcl
#
# Screen to set time zone.
#
# 20060828 RCM - created
#
# Copyright (c) 2006 IntegriNautics Corporation.
# All Rights Reserved. 
##############################################################################
namespace eval Modal { 

    #-------------------------------------------------------------------------
    # Define and pack the screen
    #-------------------------------------------------------------------------
    # All screens must create a top level frame .fmodal and destroy it on exit
    frame .fmodal

    # Define and pack the screen layout

    # Title
    frame .fmodal.title
    
    # Title Text
    label .fmodal.title.titletxt -text "Space for title" -font $huge_font
    pack .fmodal.title.titletxt -side top
    label .fmodal.title.subtext -text "Select a frequency from the list below that matches your goegraphical location\n or enter a custom frequency." -font $medium_font
     
    # Divider between title and content
    label .fmodal.title.divider -image imgDivider 
    pack .fmodal.title.divider -side top
    pack .fmodal.title.subtext -side top

    # Input frame
    frame .fmodal.input

    frame .fmodal.input.header -bd 1 -relief solid
    frame .fmodal.input.header.id -bd 1 -relief solid
    frame .fmodal.input.header.name -bd 1 -relief solid
    frame .fmodal.input.header.freq -bd 1 -relief solid
    
    label .fmodal.input.header.id.idTxt -text "ID" -font $medium_font
    label .fmodal.input.header.name.nameTxt -text "Name" -font $medium_font
    label .fmodal.input.header.freq.freqTxt -text "Frequency" \
      -font $medium_font -width 20 
       
    frame .fmodal.input.enterFreq -bd 1 -relief solid
    frame .fmodal.input.enterFreq.top -bd 1 -relief solid
    label .fmodal.input.enterFreq.top.captionLbl -text "Enter Frequency:" \
      -font $big_font
    label .fmodal.input.enterFreq.top.freq -text "0.0" \
      -relief sunken -width 15 -font $big_font
                                             
    SnazzyButton::create .fmodal.input.enterFreq.top.edit \
      btnBlueMU btnBlueMD 0.5 "beepOnce; post $DISP_BTN5_SIG 5;" "Enter"
    
    frame .fmodal.input.select
    scrollbar .fmodal.input.select.sbar \
      -command { .fmodal.input.select.lbox yview } \
      -width 40
    listbox .fmodal.input.select.lbox \
      -yscrollcommand {.fmodal.input.select.sbar set} \
      -width 30 -height 3 \
      -font $huge_font 
      
    # Create InitialAccuracy Slider
    set initacc 3
    frame .fmodal.input.slider
    label .fmodal.input.slider.title -text "Select the minimum initial accuracy required for position to be valid." \
      -font $medium_font
    scale .fmodal.input.slider.initacc -label "" -bigincrement 1 -from 1 -to 4 \
    -showvalue False   -orient  horizontal -tickinterval 1 \
	-variable initacc -length 500
	frame .fmodal.input.slider.initacctxt
	label .fmodal.input.slider.initacctxt.100cm -text "40 in/100 cm" -font $medium_font -width 10  
	label .fmodal.input.slider.initacctxt.50cm  -text "20 in/50 cm"  -font $medium_font -width 10
	label .fmodal.input.slider.initacctxt.30cm  -text "12 in/30 cm"  -font $medium_font -width 10
	label .fmodal.input.slider.initacctxt.15cm  -text "6 in/15 cm"   -font $medium_font -width 8 -justify right
	
	pack .fmodal.input.slider.initacctxt.100cm -side left  -padx 0 
	pack .fmodal.input.slider.initacctxt.50cm  -side left  -padx 35
	pack .fmodal.input.slider.initacctxt.30cm  -side left  -padx 25
	pack .fmodal.input.slider.initacctxt.15cm  -side right -padx 0 -anchor e
    
    pack .fmodal.input.header.id.idTxt -side top -padx 5
    pack .fmodal.input.header.name.nameTxt -side top
    pack .fmodal.input.header.freq.freqTxt -side top
    
    pack .fmodal.input.header.id -side left -fill x -expand yes
    pack .fmodal.input.header.name -side left -fill x -expand yes
    pack .fmodal.input.header.freq -side left -fill x -expand yes
    pack .fmodal.input.header -side top -fill x -expand yes -fill x -expand yes
    
    pack .fmodal.input.select.lbox -side left -pady 5 -fill both -expand yes 
    pack .fmodal.input.select.sbar -side left -pady 5 -fill y
    pack .fmodal.input.select -side top -fill x -expand yes
    
    pack .fmodal.input.enterFreq.top.captionLbl -side left -padx 10
    pack .fmodal.input.enterFreq.top.freq -side left -padx 10
    pack .fmodal.input.enterFreq.top.edit -side right -padx 5
    pack .fmodal.input.enterFreq.top -side top -anchor nw \
      -fill x -expand yes
    
    pack .fmodal.input.slider.title      -side top -fill x -expand yes
    pack .fmodal.input.slider.initacc    -side top -fill x -expand yes
    pack .fmodal.input.slider.initacctxt -side top -fill x -expand yes
    pack .fmodal.input.slider -side top  -pady 5   -fill x -expand yes
        
    # Cancel/Accept frame
    frame .fmodal.input2
    SnazzyButton::create .fmodal.input2.accept btnBlueU btnBlueD 0.5 \
                 "beepOnce; post $DISP_BTN0_SIG 0;" "Accept"
    SnazzyButton::create .fmodal.input2.cancel btnKhakiU btnKhakiD 0.5 \
                 "beepOnce; post $DISP_BTN9_SIG 9;" "Return To Previous Menu"           
        
    pack .fmodal.input2.cancel -side left -padx 5 -pady 5
    pack .fmodal.input2.accept -side right -padx 5 -pady 5

    # Pack .fmodal
    pack .fmodal.title -side top -pady 5 -fill x -expand yes -anchor n
    pack .fmodal.input -side top -padx 90 -anchor n -fill x -expand yes
    pack .fmodal.input2 -side bottom -anchor se -fill x -expand yes
                
    #-------------------------------------------------------------------------
    # Standard entry and exit procedures (called by GuiMgr)
    #-------------------------------------------------------------------------
    # Action called by GuiMgr on entry to this screen
    proc actEntry {} {    
        pack forget .ftop
        pack .fmodal -fill both -expand yes
    }
    
    # Action called by GuiMgr on exit from this screen
    proc actExit {} {
        destroy .fmodal
        pack .ftop -fill both -expand yes
    }
    #-------------------------------------------------------------------------
    # Screen action procedures (to be called by GuiMgr)
    #-------------------------------------------------------------------------
    proc actConfigure {titleLbl subTitleLbl returnBtn acceptBtn customBtn \
                       customLbl initacclabel initaccval} {
        global initacc
        .fmodal.title.titletxt configure -text $titleLbl
        .fmodal.title.subtext configure -text $subTitleLbl
        .fmodal.input.enterFreq.top.captionLbl configure -text $customLbl
        .fmodal.input.slider.title configure -text $initacclabel
        SnazzyButton::setText .fmodal.input2.cancel $returnBtn 0.5
        SnazzyButton::setText .fmodal.input2.accept $acceptBtn 0.5
        SnazzyButton::setText .fmodal.input.enterFreq.top.edit $customBtn 0.5
        set initacc $initaccval
    }
    
    proc actDisplayFreq {freq__} {
      .fmodal.input.enterFreq.top.freq configure -text $freq__  
    }
    
    proc actListboxInsert { item__ } {
      .fmodal.input.select.lbox insert end $item__
      #.fmodal.input.select.lbox selection set 0
    }
            
    proc actListboxGetCurselection {} {
        if { [.fmodal.input.select.lbox index end] != 0} {
            set index [lindex [.fmodal.input.select.lbox curselection] 0]
            return [.fmodal.input.select.lbox get $index]
        } else {
            return "!"             ;# ! tells the C side the listbox was empty
        }
    }
    
    proc actListboxGetCurindex {} {
      if { [.fmodal.input.select.lbox index end] != 0} {
        return [lindex [.fmodal.input.select.lbox curselection] 0]
      } else {
        return -1             ;# -1 tells the C side the listbox was empty
      }
    }
    
    bind .fmodal.input.select.lbox <ButtonPress-1> {
      beepOnce; post $DISP_BTN1_SIG 1;  
    }
    
    proc actShowChangeFrequency {} {
      pack .fmodal.input.enterFreq -side top -fill x -expand yes
    }
    
    proc actListboxSelectCurrentFrequency { freq__ } {
      # If list is not empty, try to select an item by name, if item not 
      # found select first item in list
      set items [.fmodal.input.select.lbox get 0 end]
      if { [llength $items] == 0 } {
        return
      }
      set index [lsearch -regexp $items $freq__]
      if {$index < 0} {
        set index 0
      }
      .fmodal.input.select.lbox selection set $index
      .fmodal.input.select.lbox see $index
    }
    
    proc getDefaultInitialAcc {} {
      global initacc
      return $initacc
    }
   
    #-------------------------------------------------------------------------
    # Delegated procedures
    #-------------------------------------------------------------------------

    #-------------------------------------------------------------------------
    # Local procedures
    # {MLE-020418: Tcl/Tk goal should be to get rid of all local procedures, 
    # because they represent intelligence, which the display should not have.}
    #-------------------------------------------------------------------------
    # Local procedures
}
