##############################################################################
#
# sync/src/tcl/selectbase.tcl
#
# Screen to display selectbase selections
#
# RA - created
#
# Copyright (c) 2005 Novariant Corporation.
# All Rights Reserved. 
##############################################################################
namespace eval Screen { 
    frame .ftop

    frame .ftop.title
    pack .ftop.title -side top

    label .ftop.title.title -font $large_font -width 45 \
	-text "Accept Database Changes?" -pady 10
    pack .ftop.title.title -side left

    image create photo btnBlueQuestionU -format gif -file \
	${tclPath}gif/btnBlueQuestionU.gif
    image create photo btnBlueQuestionD -format gif -file \
	${tclPath}gif/btnBlueQuestionD.gif

    SnazzyButton::create .ftop.title.help btnBlueQuestionU btnBlueQuestionD 0.5 \
	"beepOnce; post $DISP_BTN0_SIG 0" ""

    pack .ftop.title.help -side right -ipadx 10 -ipady 5

    frame .ftop.conflict
    pack .ftop.conflict -side top

    scrollbar .ftop.conflict.sbar -orient vertical \
	-command [list .ftop.conflict.localTxt yview] \
	-width 36

    set fixed_font [font create -family courier -weight bold -size -12]

    listbox .ftop.conflict.localTxt -width 80 -height 17 -font $fixed_font \
	-exportselection 0 \
	-yscrollcommand [list .ftop.conflict.sbar set] \
	-background white -selectbackground gray

    pack .ftop.conflict.sbar -side right -fill y
    pack .ftop.conflict.localTxt -side right

#     place .ftop.conflict.sbar -relx .937 -y 12 -height 277
#     place .ftop.conflict.localTxt -relx 0.467 -y 12 -anchor n

    frame .ftop.buttons
    pack .ftop.buttons -side top -fill x

    SnazzyButton::create .ftop.buttons.yes btnAcceptU btnAcceptD 0.3 \
	"beepOnce; post $DISP_BTN1_SIG 1" "Yes"

    pack .ftop.buttons.yes -side right -padx 15 -pady 5 -anchor se

    label .ftop.buttons.deleted -text "Some corrupted data was discovered\n\
and deleted from your database.\nPlease check the list above." -width 40 \
	-foreground red -font $big_font

    pack .ftop.buttons.deleted -side right -padx 5 -pady 5
    
    SnazzyButton::create .ftop.buttons.no btnRejectU btnRejectD 0.3 \
	"beepOnce; post $DISP_BTN2_SIG 2" "No"

    pack .ftop.buttons.no -side left -padx 5 -pady 5 -anchor sw

    #-------------------------------------------------------------------------
    # Standard entry and exit procedures (called by GuiMgr)
    #-------------------------------------------------------------------------
    # Action called by GuiMgr on entry to this screen
    proc actEntry { title yes no } {
	global huge_font color3 big_font

	.ftop.title.title configure -text $title
	.ftop.buttons.yes configure -text $yes
	.ftop.buttons.no configure -text $no
	.ftop.buttons.deleted configure -text "" -width 40 \
	    -foreground red -font $big_font
        pack .ftop -fill both -expand yes
    }


    # Action called by GuiMgr on exit from this screen
    proc actExit {} {
        destroy .ftop
        pack .ftop -fill both -expand yes
    }

    #-------------------------------------------------------------------------
    # Screen action procedures (to be called by GuiMgr)
    #-------------------------------------------------------------------------

    proc actListboxInsert { item } {
	#puts "selectBase -- insert $item"
	.ftop.conflict.localTxt insert end $item
    }

    proc actCopySuccess {typename entryname} {
    }

    proc actWarn { warning } {
	global big_font

	.ftop.buttons.deleted configure -text $waring -foreground red -font $big_font
    }

}
