##############################################################################
#
# vc/src/tcl/helpscreen.tcl
#
# A modal-dialog-type helpscreen.
#
# 20020625 MLE - created
#
# Copyright (c) 2002 IntegriNautics Corporation.
# All Rights Reserved. 
##############################################################################
namespace eval MainImplementHelpMore { 

    frame .mainImplementHelpMore

    frame .mainImplementHelpMore.ckb
    frame .mainImplementHelpMore.help
    frame .mainImplementHelpMore.ckb.leftspace
    frame .mainImplementHelpMore.ckb.left
    frame .mainImplementHelpMore.ckb.right
    frame .mainImplementHelpMore.ckb.left.base
    frame .mainImplementHelpMore.ckb.left.field
    frame .mainImplementHelpMore.ckb.left.job
    frame .mainImplementHelpMore.ckb.right.implement
    frame .mainImplementHelpMore.ckb.right.vehicle

    pack .mainImplementHelpMore.help -side right -pady 5
    pack .mainImplementHelpMore.ckb.leftspace -side left -anchor e -padx 60
    pack .mainImplementHelpMore.ckb.left -side left -anchor e
    pack .mainImplementHelpMore.ckb.right -side right -padx 60

    frame .mainImplementHelpMore.center
    pack .mainImplementHelpMore.center -side top -padx 60 -pady 5

    label .mainImplementHelpMore.center.l0 -text "Help" -font $huge_font -justify center
    pack .mainImplementHelpMore.center.l0 -side top -pady 5

    label .mainImplementHelpMore.center.l1 -text "Synchronize User Data" \
	-font $big_font -pady 5 -justify center

    pack .mainImplementHelpMore.center.l1 -side top

    label .mainImplementHelpMore.center.l2 -text \
	"This screen allows you to select the types of data that you would like to \
have\n\synchronized." \
	-font $small_font -justify left -foreground red -pady 5

    pack .mainImplementHelpMore.center.l2 -anchor w -side top

    image create photo checkboxD1 \
            -format gif \
            -file ${tclPath}gif/checkboxD.gif

    image create photo checkboxU1 \
            -format gif \
            -file ${tclPath}gif/checkboxU.gif

    label .mainImplementHelpMore.ckb.left.base.btn -image checkboxD1
    label .mainImplementHelpMore.ckb.left.base.label -text "Base Stations" -font $big_font \
	-anchor e

    canvas .mainImplementHelpMore.ckb.left.field.c1 -width 35 -height 36
    .mainImplementHelpMore.ckb.left.field.c1 create line 15 0 15 25 35 25 -width 2

    canvas .mainImplementHelpMore.ckb.left.job.c2 -width 70 -height 30
    .mainImplementHelpMore.ckb.left.job.c2 create line 52 0 52 20 70 20 -width 2

    label .mainImplementHelpMore.ckb.left.field.btn -image checkboxD1

    label .mainImplementHelpMore.ckb.left.field.label -text "Fields" -font $big_font

    label .mainImplementHelpMore.ckb.left.job.btn -image checkboxD1
    label .mainImplementHelpMore.ckb.left.job.label -text "Jobs" -font $big_font

    label .mainImplementHelpMore.ckb.right.implement.btn -image checkboxD1
    label .mainImplementHelpMore.ckb.right.implement.label -text "Implements" -font $big_font

    label .mainImplementHelpMore.ckb.right.vehicle.btn -image checkboxD1
    label .mainImplementHelpMore.ckb.right.vehicle.label -text "Vehicles" -font $big_font

    pack .mainImplementHelpMore.ckb -side top -pady 5
    pack .mainImplementHelpMore.ckb.right.implement -anchor w -side top -pady 5
    pack .mainImplementHelpMore.ckb.right.vehicle -anchor w -side top -pady 5
    pack .mainImplementHelpMore.ckb.left.base -anchor w -side top
    pack .mainImplementHelpMore.ckb.left.field.c1 -anchor n -side left
    pack .mainImplementHelpMore.ckb.left.field -anchor w -side top
    pack .mainImplementHelpMore.ckb.left.job.c2 -anchor n -side left
    pack .mainImplementHelpMore.ckb.left.job -anchor w -side top

    pack .mainImplementHelpMore.ckb.left.base.label -side right
    pack .mainImplementHelpMore.ckb.left.field.label -side right
    pack .mainImplementHelpMore.ckb.left.job.label -side right
    pack .mainImplementHelpMore.ckb.right.implement.label -side right
    pack .mainImplementHelpMore.ckb.right.vehicle.label -side right
    pack .mainImplementHelpMore.ckb.left.base.btn -side left
    pack .mainImplementHelpMore.ckb.left.field.btn -side left -anchor s -pady 10
    pack .mainImplementHelpMore.ckb.left.job.btn -side left -pady 5
    pack .mainImplementHelpMore.ckb.right.implement.btn -side left
    pack .mainImplementHelpMore.ckb.right.vehicle.btn -side left

    label .mainImplementHelpMore.center.l3 -text \
	"Selecting Fields will cause Base Stations to be selected." \
	-font $small_font -justify left -foreground red -pady 5

    pack .mainImplementHelpMore.center.l3 -anchor w -side top

    label .mainImplementHelpMore.center.l4 -text \
	"Selecting Jobs will cause Base Stations and Fields to be selected." \
	-font $small_font -justify left -foreground red -pady 5

    pack .mainImplementHelpMore.center.l4 -anchor w -side top
    
    proc actSetStrings { l0 l1 l2 bs field job impl veh l3 l4 } {
	.mainImplementHelpMore.center.l0 configure -text $l0
	.mainImplementHelpMore.center.l1 configure -text $l1
	.mainImplementHelpMore.center.l2 configure -text $l2
	.mainImplementHelpMore.ckb.left.base.label configure -text $bs
	.mainImplementHelpMore.ckb.left.field.label configure -text $field
	.mainImplementHelpMore.ckb.left.job.label configure -text $job
	.mainImplementHelpMore.ckb.right.implement.label configure -text $impl
	.mainImplementHelpMore.ckb.right.vehicle.label configure -text $veh
	.mainImplementHelpMore.center.l3 configure -text $l3
	.mainImplementHelpMore.center.l4 configure -text $l4
    }

    proc Exit { } {
	destroy .mainImplementHelpMore
    }
}
