##############################################################################
#
# vc/src/tcl/helpscreen.tcl
#
# A modal-dialog-type helpscreen.
#
# 20020625 MLE - created
#
# Copyright (c) 2002 IntegriNautics Corporation.
# All Rights Reserved. 
##############################################################################
namespace eval BaseBoth { 
    frame .baseboth
    label .baseboth.title1 -text "Help" -font $huge_font -justify center
    label .baseboth.title2 -text "Synchronize Base Stations" -font $big_font -justify center
    label .baseboth.title3 -text "Base Station in Both Locations" -font $big_font -justify center

    pack .baseboth.title1 -side top
    pack .baseboth.title2 -side top
    pack .baseboth.title3 -side top

    frame .baseboth.helpdisplay -width 400 -height 350
    pack .baseboth.helpdisplay  -side right -padx 15 -expand yes -fill x

    frame .baseboth.buttons -width 150 -height 400
    pack .baseboth.buttons -side left

    SnazzyButton::create .baseboth.buttons.toRemote btnBlueM2U btnBlueM2D \
	0.5 "" "<< Copy"

    SnazzyButton::create .baseboth.buttons.toLocal btnBlueM2U btnBlueM2D \
	0.5 "" "Copy >>"

    pack .baseboth.buttons.toRemote -side top -anchor w  
    pack .baseboth.buttons.toLocal -side top -anchor w -pady 20

    label .baseboth.helpdisplay.l1 -text "Use the << copy button to copy the base station\
                                          data from\nthe GPS Station to the Compact Flash Card.\n\n" \
	-font $small_font -justify left -foreground red
    pack .baseboth.helpdisplay.l1 -side top -anchor w

    label .baseboth.helpdisplay.l2 -text "Use the copy >> button to copy the base station\
                                          data from\nthe Compact Flash Card to the GPS Station.\n\n" \
	-font $small_font -justify left -foreground red
    pack .baseboth.helpdisplay.l2 -side top -anchor w

    label .baseboth.helpdisplay.l3 -text "Note: The base station will remain in conflict until\nany associated fields and jobs\
                                          are also copied.\n\n" \
	-font $small_font -justify left -foreground red
    pack .baseboth.helpdisplay.l3 -side top -anchor w

    label .baseboth.helpdisplay.l4 -text "You may choose to copy as much or as little of the\nfield and job data as you \
                                          desire." \
	-font $small_font -justify left -foreground red
    pack .baseboth.helpdisplay.l4 -side top -anchor w

    proc actSetStrings { t1 t2 t3 b1 b2 l1 l2 l3 l4} {
	.baseboth.title1 configure -text $t1
	.baseboth.title2 configure -text $t2
	.baseboth.title3 configure -text $t3
	.baseboth.buttons.toRemote configure -text $b1
	.baseboth.buttons.toLocal configure -text $b2
	.baseboth.helpdisplay.l1 configure -text $l1
	.baseboth.helpdisplay.l2 configure -text $l2
	.baseboth.helpdisplay.l3 configure -text $l3
	.baseboth.helpdisplay.l4 configure -text $l4
    }

    proc Exit {} {
	destroy .baseboth
    }
}
