##############################################################################
#
# vc/src/tcl/helppanel.tcl
#
# Defines packable widgets to facilitate entry of various data types
# 
# 20080319 DEH Created
#
# Copyright (c) 2008 Novariant Inc
# All Rights Reserved. 
##############################################################################

#-------------------------------------------------------------------------
# HelpPanel
#-------------------------------------------------------------------------
namespace eval HelpPanel {

    #-------------------------------------------------------------------------
    # Define and pack the help panel
    #-------------------------------------------------------------------------
    # Top level frame
    frame .helppanel

    # Title
    label .helppanel.title -text "Help Screen" -font $big_font

    # Input frame
    frame .helppanel.input

    # "part of" for multiple help screens
    label .helppanel.input.part  -text "  "  -font $small_font

    label .helppanel.input.helptext  -text "description  "  -font $small_font
  
    # Pack .ftop
    pack .helppanel.title -side top -pady 10 -fill both -expand yes
    pack .helppanel.input -side top -pady 10 -pady 5

    pack .helppanel.input.part -side top -pady 10 -pady 5
    pack .helppanel.input.helptext -side top -pady 10 -pady 5

    proc actDisplayTitle { text__ } {

        .helppanel.title configure -text $text__
    }

    proc actDisplayText { text__ } {

        .helppanel.input.helptext configure -text $text__
    }

    proc actDisplayPartText { text__ } {

        .helppanel.input.part configure -text $text__
    }

    proc actReset { } {
        pack forget .helppanel.title
        pack forget .helppanel.input.part 
        pack forget .helppanel.input.helptext
     }
}

