##############################################################################
#
# vc/src/tcl/implementtune.tcl
#
# 
#
# 20061017
#
# Copyright (c) 2002 IntegriNautics Corporation.
# All Rights Reserved. 
##############################################################################
namespace eval Screen { 


    #-------------------------------------------------------------------------
    # Define and pack the screen
    #-------------------------------------------------------------------------
    # All screens must create a top level frame .ftop and destroy it in sExit
    frame .ftop

    # title and field boundary indicator
    label .ftop.l1 -text "Implement Tuning"
    pack .ftop.l1 -side top

    # divide remainder into subframes
    # frame for control parameters and navigation
    frame .ftop.params
    frame .ftop.params.listboxframe
    label .ftop.params.spacer
#    SnazzyButton::create .ftop.params.parameter btnKhakiU \
#       btnKhakiD 0.5 "beepOnce; post $DISP_BTN2_SIG 0 \"parameter\"" "View Parameter"
    label .ftop.params.listboxframe.l -text "Select Parameter" -relief raised
    bind .ftop.params.listboxframe.l <ButtonPress-1> \
        { beepOnce; post $DISP_BTN2_SIG 1 }
    scrollbar .ftop.params.listboxframe.sbar -orient vertical -width 30 \
            -command { .ftop.params.listboxframe.lbox yview }
    listbox .ftop.params.listboxframe.lbox -font $big_font \
            -yscrollcommand {.ftop.params.listboxframe.sbar set} \
            -width 35 -height 10
    pack .ftop.params.spacer -side top
#    pack .ftop.params.parameter -side top -padx 5 -pady 5 -anchor w
    pack .ftop.params.listboxframe.l -side top -anchor w
    pack .ftop.params.listboxframe.sbar -side right -fill y
    pack .ftop.params.listboxframe.lbox -side right
    pack .ftop.params.listboxframe -side top -fill x

    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Cancel
    SnazzyButton::create .ftop.params.keycancel btnKhakiU \
       btnKhakiD 0.5 "beepOnce; post $DISP_BTN0_SIG 0 \"cancel\"" "Cancel"
    pack .ftop.params.keycancel -side left -padx 5 -pady 5 -anchor sw
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Edit
    SnazzyButton::create .ftop.params.keyedit btnBlueU \
            btnBlueD 0.5 "beepOnce; post $DISP_BTN8_SIG 0 \"edit\"" "Edit"


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Enter
    SnazzyButton::create .ftop.params.keyenter btnGreenU \
            btnGreenD 0.5 "beepOnce; post $DISP_BTN1_SIG 0 \"enter\"" "Enter"
    pack .ftop.params.keyenter -side right -padx 5 -pady 5 -anchor se
    pack .ftop.params.keyedit -side right -padx 5 -pady 5 -anchor se

    # numpad frame
    frame .ftop.numpad

    # display frame
    frame .ftop.numpad.display
    label .ftop.numpad.display.l -text "Value"
    label .ftop.numpad.display.e \
            -relief sunken -font $big_font -width 20 -anchor w
    pack .ftop.numpad.display.e -side bottom -pady 5 -anchor sw -padx 25
    pack .ftop.numpad.display.l -side top -padx 5 -pady 5 -anchor w

    # buttons frame
    frame .ftop.numpad.but
    pack .ftop.numpad.but -side bottom -pady 5 -fill both -expand yes
    pack .ftop.numpad.display -side top -pady 5 -fill x -expand yes

    # 4 rows in the numpad...
    foreach r {4 3 2 1} {
        frame .ftop.numpad.but.row$r
        pack .ftop.numpad.but.row$r -side bottom -padx 10 -fill x
    }

    # special keys...
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Key pm +/-
    SnazzyButton::create .ftop.numpad.but.row4.keypm btnBlueS2U \
             btnBlueS2D 0.5 "beepOnce; post $DISP_BTN3_SIG 0 \"+/-\"" "+/-"
    pack .ftop.numpad.but.row4.keypm -side left -padx 1 -pady 5
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ backspace
    SnazzyButton::create .ftop.numpad.but.row4.keybksp btnBlueS2U \
         btnBlueS2D 0.5 "beepOnce; post $DISP_BTN4_SIG 0 \"backspace\"" "Bksp"
    pack .ftop.numpad.but.row4.keybksp -side left -padx 1 -pady 5
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Key dot
    SnazzyButton::create .ftop.numpad.but.row4.keydot btnBlueS2U \
             btnBlueS2D 0.5 "beepOnce; post $DISP_BTN5_SIG 0 \"dot\"" "."
    pack .ftop.numpad.but.row4.keydot -side left -padx 1 -pady 5
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Key 0
    SnazzyButton::create .ftop.numpad.but.row4.key0 btnBlueS2U \
             btnBlueS2D 0.5 "beepOnce; post $DISP_BTN6_SIG 0 \"0\"" "0"
    pack .ftop.numpad.but.row4.key0 -side left -padx 1 -pady 5

    # numeric buttons...
    foreach {r k} {1 1 1 2 1 3 \
                   2 4 2 5 2 6 \
                   3 7 3 8 3 9} {
                set cmd "beepOnce; post $DISP_BTN7_SIG $k \"$k\""
               eval { \
                      SnazzyButton::create .ftop.numpad.but.row$r.key$k \
                        btnBlueS2U btnBlueS2D 0.5 $cmd
                      SnazzyButton::setText .ftop.numpad.but.row$r.key$k \
                        $k 0.5   
               pack .ftop.numpad.but.row$r.key$k -side left -padx 1 \
                       -pady 5
	       }
    }

    pack .ftop.params -side left -fill both -expand yes -anchor sw
    pack .ftop.numpad -side right -fill both -expand yes -anchor se


    #-------------------------------------------------------------------------
    # Entry and exit procedures
    #-------------------------------------------------------------------------
    proc actEntry {cancelBtn enterBtn controlTag } {
        SnazzyButton::setText .ftop.params.keycancel $cancelBtn 0.5
        SnazzyButton::setText .ftop.params.keyenter $enterBtn 0.5
	.ftop.params.listboxframe.l configure -text $controlTag
        pack .ftop -fill both -expand yes
    }

    
    proc actExit {} {
        destroy .ftop
        pack .ftop -fill both -expand yes
    }

    proc actListboxClear {  } {
        .ftop.params.listboxframe.lbox delete 0 end
    }

    proc actListboxInsert { item } {
        .ftop.params.listboxframe.lbox insert end $item
    }

    proc actListboxSelectItem { item__ } {
        # If list is not empty, try to select an item by name, if item not 
        # found select first item in list
        set items [.ftop.params.listboxframe.lbox get 0 end]
        if { [llength $items] == 0 } {
            return
        }
        set index [lsearch -exact $items $item__]
        if {$index < 0} {
            set index 0
        }
        .ftop.params.listboxframe.lbox selection set $index
        .ftop.params.listboxframe.lbox see $index
    }

    bind .ftop.params.listboxframe.lbox <ButtonPress-1> {
      beepOnce; post $DISP_BTN2_SIG 0;  
    } 

    proc actListboxGetCurindex {} {
      if { [.ftop.params.listboxframe.lbox index end] != 0} {
          return [lindex [.ftop.params.listboxframe.lbox curselection] 0]
      } else {
          return -1             ;# -1 tells the C side the listbox was empty
      }
    }

    proc actHighLightBtn {subMsgId} {
        .ftop.params.listboxframe.lbox selection set $subMsgId
        .ftop.params.listboxframe.lbox see $subMsgId
    }

    proc actDisp {text__} {
        .ftop.numpad.display.e configure -text $text__
    }

    proc actSetLabel {text__} {
	.ftop.params.listboxframe.l configure -text $text__
    }

}
