##############################################################################
#
# vc/src/tcl/impltoglpanel.tcl
#
# Defines packable widgets to facilitate entry of various data types
# 
# 20080403 DEH Created
#
# Copyright (c) 2008 Novariant Inc
# All Rights Reserved. 
##############################################################################


#-------------------------------------------------------------------------
# MsgPanel
#-------------------------------------------------------------------------
namespace eval ImplToglPanel {

    #-------------------------------------------------------------------------
    # Define and pack the toglpanel
    #-------------------------------------------------------------------------
    # Top level frame
    frame .impltoglpanel

    # Input frame
    frame .impltoglpanel.header
    frame .impltoglpanel.display
    frame .impltoglpanel.footer

    label .impltoglpanel.header.l -text "" -font $huge_font
    pack .impltoglpanel.header.l -side top -expand yes -fill x
    label .impltoglpanel.footer.l -text "" -font $big_font
    pack .impltoglpanel.footer.l -side top -expand yes -fill x

    # Pack .impltoglpanel
    pack .impltoglpanel.header -side top
    pack .impltoglpanel.display -side top
    pack .impltoglpanel.footer -side top


    proc actShowAngleWidget {} {
	pack .glImplementStatusDisp -in .impltoglpanel.display \
	    -side top -anchor n
	raise .glImplementStatusDisp
    }

    proc actSetHeaderText { headerText } {
        .impltoglpanel.header.l configure -text $headerText
    }

    proc actSetFooterText { footerText } {
        .impltoglpanel.footer.l configure -text $footerText
    }

}

