##############################################################################
#
# vc/src/tcl/labelpanel.tcl
#
# Defines packable widgets to facilitate entry of various data types
# 
# 20080319 DEH Created
#
# Copyright (c) 2008 Novariant Inc
# All Rights Reserved. 
##############################################################################

#-------------------------------------------------------------------------
# LabelPanel
#-------------------------------------------------------------------------
namespace eval LabelPanel {

    #-------------------------------------------------------------------------
    # Define and pack the labelpanel
    #-------------------------------------------------------------------------
    # Top level frame
    frame .labelpanel

    # Title
    label .labelpanel.title -text "??Space for title"

    # Input frame
    frame .labelpanel.input

    # Row 1
    frame .labelpanel.input.r1
    label .labelpanel.input.r1.l -text "Name:" -font $big_font -width 20 -anchor e
    label .labelpanel.input.r1.e -text "foo" -font $big_font \
                -width 32 -anchor w -relief sunken -borderwidth 2
    pack .labelpanel.input.r1.l -side left -pady 5
    pack .labelpanel.input.r1.e -side left -padx 10 -pady 5
       
    # Row 2
    frame .labelpanel.input.r2
    label .labelpanel.input.r2.l -text "Type:" -font $big_font -width 20 -anchor e
    label .labelpanel.input.r2.e -text "Hitched" -font $big_font \
                  -width 32 -anchor w -relief sunken -borderwidth 2
    pack .labelpanel.input.r2.l -side left -pady 5 -anchor w
    pack .labelpanel.input.r2.e -side left -padx 10 -pady 5

    # Row 3
    frame .labelpanel.input.r3
    label .labelpanel.input.r3.l -text "Width:" -font $big_font -width 20 -anchor e
    label .labelpanel.input.r3.e -text "xx feet xx inch" -font $big_font \
                  -width 32 -anchor w -relief sunken -borderwidth 2
    pack .labelpanel.input.r3.l -side left -pady 5 -anchor w
    pack .labelpanel.input.r3.e -side left -padx 10 -pady 5

    # Row 4
    frame .labelpanel.input.r4
    label .labelpanel.input.r4.l -text "Offset:" -font $big_font -width 20 -anchor e
    label .labelpanel.input.r4.e -text "xx feet xx inch" -font $big_font \
                  -width 32 -anchor w -relief sunken -borderwidth 2
    pack .labelpanel.input.r4.l -side left -pady 5 -anchor w
    pack .labelpanel.input.r4.e -side left -padx 10 -pady 5
 
   # Row 5
    frame .labelpanel.input.r5
    label .labelpanel.input.r5.l -text "Steering Method:" -font $big_font -width 20 -anchor e
    label .labelpanel.input.r5.e -text "Orthman" -font $big_font \
                  -width 32 -anchor w -relief sunken -borderwidth 2
    pack .labelpanel.input.r5.l -side left -pady 5 -anchor w
    pack .labelpanel.input.r5.e -side left -padx 10 -pady 5


    # Pack rows
    pack .labelpanel.input.r1 -side top -anchor w -fill x
    pack .labelpanel.input.r2 -side top -anchor w -fill x
    pack .labelpanel.input.r3 -side top -anchor w -fill x
    pack .labelpanel.input.r4 -side top -anchor w -fill x
    pack .labelpanel.input.r5 -side top -anchor w -fill x

    # Pack .ftop
    pack .labelpanel.title -side top -pady 10 -fill both -expand yes
    pack .labelpanel.input -side top -pady 10 -pady 5

    proc actDisplaySunkenLabels { topLabel__ name__ type__ width__ offset__ lineAcq__ } {

	pack forget .labelpanel.input.r5.e
	pack forget .labelpanel.input.r5.l
        .labelpanel.title configure -text $topLabel__
        .labelpanel.input.r1.e configure -text $name__
        .labelpanel.input.r2.e configure -text $type__
        .labelpanel.input.r3.e configure -text $width__
        .labelpanel.input.r4.e configure -text $offset__

	if {$lineAcq__ != "!"} {
	    .labelpanel.input.r5.e configure -text $lineAcq__
	    pack .labelpanel.input.r5.l -side left -pady 5 -anchor w
	    pack .labelpanel.input.r5.e -side left -padx 10 -pady 5
	}
    }

    proc actCfgImages { name__ type__ width__ offset__ lineAcq__ } {
        .labelpanel.input.r1.l configure -image $name__
        .labelpanel.input.r2.l configure -image $type__
        .labelpanel.input.r3.l configure -image $width__
        .labelpanel.input.r4.l configure -image $offset__
        .labelpanel.input.r5.l configure -image $lineAcq__
        .labelpanel.input.r1.l configure -text ""
        .labelpanel.input.r2.l configure -text ""
        .labelpanel.input.r3.l configure -text ""
        .labelpanel.input.r4.l configure -text ""
        .labelpanel.input.r5.l configure -text ""
    }

    proc actCfgLabels { name__ type__ width__ offset__ lineAcq__ } {
        .labelpanel.input.r1.l configure -text $name__
        .labelpanel.input.r2.l configure -text $type__
        .labelpanel.input.r3.l configure -text $width__
        .labelpanel.input.r4.l configure -text $offset__
        .labelpanel.input.r5.l configure -text $lineAcq__
        .labelpanel.input.r1.l configure -image ""
        .labelpanel.input.r2.l configure -image ""
        .labelpanel.input.r3.l configure -image ""
        .labelpanel.input.r4.l configure -image ""
        .labelpanel.input.r5.l configure -image ""
    }

    proc actCfgLabelsFlat { } {
        .labelpanel.title configure -relief flat -borderwidth 0
        .labelpanel.input.r1.e configure -relief flat -borderwidth 0
        .labelpanel.input.r2.e configure -relief flat -borderwidth 0
        .labelpanel.input.r3.e configure -relief flat -borderwidth 0
        .labelpanel.input.r4.e configure -relief flat -borderwidth 0
        .labelpanel.input.r5.e configure -relief flat -borderwidth 0
    }

    proc actConfigureLabelsSunken { } {
        .labelpanel.title configure -relief sunken -borderwidth 2
        .labelpanel.input.r1.e configure -relief sunken -borderwidth 2
        .labelpanel.input.r2.e configure -relief sunken -borderwidth 2
        .labelpanel.input.r3.e configure -relief sunken -borderwidth 2
        .labelpanel.input.r4.e configure -relief sunken -borderwidth 2
        .labelpanel.input.r5.e configure -relief sunken -borderwidth 2
    }

    proc actDisplayLeftLabels {name__ type__ width__ offset__ lineAcq__ } {
        .labelpanel.input.r1.l configure -text $name__
        .labelpanel.input.r2.l configure -text $type__
        .labelpanel.input.r3.l configure -text $width__
        .labelpanel.input.r4.l configure -text $offset__
	.labelpanel.input.r5.l configure -text $lineAcq__
    }    

    proc actDisplayTitle { topLabel__ } {

        .labelpanel.title configure -text $topLabel__
    }

    proc actSetImages { l1 l2 l3 l4 l5 } {
	actCfgLabels "" "" "" "" ""
	if { $l1 != "!" } {
	    .labelpanel.input.r1.l configure -image $l1
	    pack .labelpanel.input.r1.l -side left -pady 5 -anchor w
	}
	if { $l2 != "!" } {
	    .labelpanel.input.r2.l configure -image $l2
	    pack .labelpanel.input.r2.l -side left -pady 5 -anchor w
	}
	if { $l3 != "!" } {
	    .labelpanel.input.r3.l configure -image $l3
	    pack .labelpanel.input.r3.l -side left -pady 5 -anchor w
	}
	if { $l4 != "!" } {
	    .labelpanel.input.r4.l configure -image $l4
	    pack .labelpanel.input.r4.l -side left -pady 5 -anchor w
	}
	if { $l5 != "!" } {
	    .labelpanel.input.r5.l configure -image $l5
	    pack .labelpanel.input.r5.l -side left -pady 5 -anchor w
	}
    }

    proc actSetStrings { tit e1 e2 e3 e4 e5 } {
	actCfgLabelsFlat
	actDisplaySunkenLabels "" "" "" "" "" ""
	.labelpanel.title configure -text $tit
	if { $e1 != "!" } {
	    .labelpanel.input.r1.e configure -text $e1
	    pack .labelpanel.input.r1.e -side left -padx 10 -pady 5
	}
	if { $e2 != "!" } {
	    .labelpanel.input.r2.e configure -text $e2
	    pack .labelpanel.input.r2.e -side left -padx 10 -pady 5
	}
	if { 4e3 != "!" } {
	    .labelpanel.input.r3.e configure -text $e3
	    pack .labelpanel.input.r3.e -side left -padx 10 -pady 5
	}
	if { $e4 != "!" } {
	    .labelpanel.input.r4.e configure -text $e4
	    pack .labelpanel.input.r4.e -side left -padx 10 -pady 5
	}
	if { $e5 != "!" } {
	    .labelpanel.input.r5.e configure -text $e5
	    pack .labelpanel.input.r5.e -side left -padx 10 -pady 5
	}
    }

    proc actExit {} {
#        pack forget .labelpanel.title
        pack forget .labelpanel.input.r1.e
        pack forget .labelpanel.input.r2.e
        pack forget .labelpanel.input.r3.e
        pack forget .labelpanel.input.r4.e
        pack forget .labelpanel.input.r5.e
        pack forget .labelpanel.input.r1.l
        pack forget .labelpanel.input.r2.l
        pack forget .labelpanel.input.r3.l
        pack forget .labelpanel.input.r4.l
        pack forget .labelpanel.input.r5.l
    }

    proc Exit {} {
	actExit
    }
}



