##############################################################################
#
# vc/src/tcl/msgpanel.tcl
#
# Defines packable widgets to facilitate entry of various data types
# 
# 20080319 DEH Created
#
# Copyright (c) 2008 Novariant Inc
# All Rights Reserved. 
##############################################################################


#-------------------------------------------------------------------------
# MsgPanel
#-------------------------------------------------------------------------
namespace eval MsgPanel {

    #-------------------------------------------------------------------------
    # Define and pack the messagepanel
    #-------------------------------------------------------------------------
    # Top level frame
    frame .msgpanel

    # Title
    label .msgpanel.title -text "??Space for title"

    # Input frame
    frame .msgpanel.input

    label .msgpanel.input.l1 -text "" -font $big_font -justify left
    label .msgpanel.input.l2 -text "" -font $big_font -justify left
    label .msgpanel.input.l3 -text "" -font $big_font -justify left
    label .msgpanel.input.l4 -text "" -font $big_font -justify left
    label .msgpanel.input.l5 -text "" -font $medium_font -justify left

    # Pack .msgpanel
    pack .msgpanel.title -side top -pady 1 -fill both -expand yes
    pack .msgpanel.input -side top -anchor w -expand yes -fill x
    pack .msgpanel.input.l1 -side top -anchor w -expand yes -fill x
    pack .msgpanel.input.l2 -side top -anchor w -expand yes -fill x
    pack .msgpanel.input.l3 -side top -anchor w -expand yes -fill x
    pack .msgpanel.input.l4 -side top -anchor w -expand yes -fill x
    pack .msgpanel.input.l5 -side top -anchor w -expand yes -fill x

    proc actDisplayLabel { topLabel__ } {

        .msgpanel.title configure -text $topLabel__

    }

    proc actSetFontsToLarge {  } {
	global large_font
        .msgpanel.title configure -font $large_font
        .msgpanel.input.l1 configure -font $large_font
        .msgpanel.input.l3 configure -font $large_font
        .msgpanel.input.l5 configure -font $large_font
    }

    proc actDisplayWarning { warningText riskStatement furtherStatement  } {

        .msgpanel.input.l1 configure -text $warningText -foreground red
        .msgpanel.input.l3 configure -text $riskStatement 
        .msgpanel.input.l5 configure -text $furtherStatement -justify left

	pack .msgpanel.input.l1 -side top -anchor w -expand yes -fill x
	pack .msgpanel.input.l2 -side top -anchor w -expand yes -fill x
	pack .msgpanel.input.l3 -side top -anchor w -expand yes -fill x
	pack .msgpanel.input.l4 -side top -anchor w -expand yes -fill x
	pack .msgpanel.input.l5 -side top -anchor w -expand yes -fill x
    }

    proc actResetPanel { } {
	actRemoveWarning
	pack .msgpanel.input.l1 -side top -anchor w -expand yes -fill x
	pack .msgpanel.input.l2 -side top -anchor w -expand yes -fill x
	pack .msgpanel.input.l3 -side top -anchor w -expand yes -fill x
	pack .msgpanel.input.l4 -side top -anchor w -expand yes -fill x
	pack .msgpanel.input.l5 -side top -anchor w -expand yes -fill x
    }

    proc actResetPanel3 { } {
	actRemoveWarning
	pack .msgpanel.input.l1 -side top -anchor w -expand yes -fill x
	pack .msgpanel.input.l2 -side top -anchor w -expand yes -fill x
	pack .msgpanel.input.l3 -side top -anchor w -expand yes -fill x
    }

    proc actSetRowImage { row imageName } {
        .msgpanel.input.l$row configure -image $imageName
    }

    proc actSetRowLabel { row label } {
        .msgpanel.input.l$row configure -text $label -justify left -foreground black
    }

    proc actRemoveWarning { } {
        .msgpanel.input.l1 configure -text ""
        .msgpanel.input.l2 configure -text ""
        .msgpanel.input.l3 configure -text ""
        .msgpanel.input.l4 configure -text ""
        .msgpanel.input.l5 configure -text ""

        .msgpanel.input.l1 configure -image ""
        .msgpanel.input.l2 configure -image ""
        .msgpanel.input.l3 configure -image ""
        .msgpanel.input.l4 configure -image ""
        .msgpanel.input.l5 configure -image ""

        pack forget .msgpanel.input.l1 
        pack forget .msgpanel.input.l2 
        pack forget .msgpanel.input.l3 
        pack forget .msgpanel.input.l4 
        pack forget .msgpanel.input.l5 
    }
}


