##############################################################################
#
# vc/src/tcl/pingvehicle.tcl
#
# Ping Vehicle Via Can Bus Screen
#
# 20050317 QC - created
#
# Copyright (c) 2005 Novariant Corporation.
# All Rights Reserved. 
##############################################################################
namespace eval Screen { 

    #-------------------------------------------------------------------------
    # Define and pack the screen
    #-------------------------------------------------------------------------
    # All screens must create a top level frame .ftop and destroy it in Exit

    frame .ftop
    
    frame .ftop.display
    
    label .ftop.display.l -text "PING VEHICLE VIA CAN BUS" -font $huge_font
    

    pack .ftop.display.l -side top -pady 100
    pack .ftop.display -side top
    
#    frame .ftop.display2
#    canvas .ftop.display2.c -width 630 -height 100 -relief sunken \
#                            -borderwidth 0 -background $color6
#    .ftop.display2.c create text 212 110 -text "\n\n\n     " -font $medium_font -tag rmstatus
                                                                
#    pack .ftop.display2.c -side top -pady 20
#    pack .ftop.display2 -side top
    
    frame .ftop.input
    pack .ftop.input -side bottom -padx 5 -pady 5 -fill both -expand yes
    canvas .ftop.input.c -width 405 -height 110 -relief sunken \
                            -borderwidth 0 -background $color6
    .ftop.input.c create image 100 20 -image btnGREEN -tag pingImage
    .ftop.input.c create text 230 20 -text "Ping Test Result" \
                            -font $medium_font -tag pingTag
    .ftop.input.c create text 205 65 -text "" -font $medium_font -tag pingTxt
                                                    
    SnazzyButton::create .ftop.input.exit btnKhakiU btnKhakiD 0.5 \
           "beepOnce; post $DISP_BTN9_SIG 9;" "Return\nTo\nPrevious\nMenu"
    pack .ftop.input.exit -side left -anchor sw
    pack .ftop.input.c -side left -anchor sw

    SnazzyButton::create .ftop.input.continue btnBlueU btnBlueD 0.5 \
                           "beepOnce; post $DISP_BTN1_SIG 1;" "Ping\nTest"   
    pack .ftop.input.continue -side right -anchor se

    #-------------------------------------------------------------------------
    # Standard entry and exit procedures (called by GuiMgr)
    #-------------------------------------------------------------------------
    # Action called by GuiMgr on entry to this screen
    proc actEntry {} {

      pack .ftop -fill both -expand yes
    }
    
    # Action called by GuiMgr on exit from this screen
    proc actExit {} {

        destroy .ftop

    }
   
    #-------------------------------------------------------------------------
    # Screen action procedures (to be called by GuiMgr)
    #-------------------------------------------------------------------------
    # Update procedures of this template can be called by the GuiMgr
    proc actEnablePingBtn {} {

        .ftop.input.continue configure -state normal

    }

    proc actDisablePingBtn {} {

        .ftop.input.continue configure -state disabled
        .ftop.input.c itemconfigure pingTag -text "Pinging Vehicle"
        .ftop.input.c itemconfigure pingImage -image btnGREY
        .ftop.input.c itemconfigure pingTxt -text ""

    }

    proc actPingResult {num1 num2} {
        if {$num1 == $num2} {
          .ftop.input.c itemconfigure pingTag -text "Ping Successful"
          .ftop.input.c itemconfigure pingImage -image btnGREEN
          .ftop.input.c itemconfigure pingTxt -text "Packets: Sent = $num1, Received = $num2, Lost = 0 <0% Loss>"
        }
        if {$num1 != $num2} {
          .ftop.input.c itemconfigure pingTag -text "Ping Failed"
          if {$num1 == 10} {
            .ftop.input.c itemconfigure pingTag -text "Time out. No response received"
          } 
          .ftop.input.c itemconfigure pingImage -image btnRED
          set lostpkt [expr $num1 - $num2]
          set lostpercent [expr $lostpkt/$num1*100]
          .ftop.input.c itemconfigure pingTxt -text "Packets: Sent = $num1, Received = $num2, Lost = $lostpkt <$lostpercent% loss>"
        }

    }

    proc actDisplayDiag { info } {

        .ftop.display2.c itemconfigure rmstatus -text $info

    }

}




