##############################################################################
#
# vc/src/tcl/databasediff.tcl
#
# Screen to show database diff.
#
# 20050802 QC - created
#
# Copyright (c) 2004 IntegriNautics Corporation.
# All Rights Reserved. 
##############################################################################
namespace eval Screen { 

    #-------------------------------------------------------------------------
    # Define and pack the screen
    #-------------------------------------------------------------------------
    # All screens must create a top level frame .ftop and destroy it on exit
    frame .ftop

    # Define and pack the screen layout

    # Title
    label .ftop.title -text "Autofarm Postmortum"
                                                                                
    # Cancel/Accept frame
    frame .ftop.input2
    SnazzyButton::create .ftop.input2.cancel \
                 btnKhakiForSatVUU btnKhakiForSatVUD 0.5 \
                 "beepOnce; post $DISP_BTN9_SIG 9;" "Exit"
        
    pack .ftop.input2.cancel -side left -padx 1 -anchor se

    # Pack .ftop
    pack .ftop.title -side top -pady 80
    pack .ftop.input2 -side bottom -anchor sw -padx 5 -pady 5 -fill both -expand yes
                
    #-------------------------------------------------------------------------
    # Standard entry and exit procedures (called by GuiMgr)
    #-------------------------------------------------------------------------
    # Action called by GuiMgr on entry to this screen
    proc actEntry {titleLbl returnBtn} {
 
      .ftop.title configure -text $titleLbl
      SnazzyButton::setText .ftop.input2.cancel $returnBtn 0.5

      pack .ftop -fill both -expand yes
    }

    # Action called by GuiMgr on exit from this screen
    proc actExit {} {
        destroy .ftop
    }

    #-------------------------------------------------------------------------
    # Screen action procedures (to be called by GuiMgr)
    #-------------------------------------------------------------------------
    proc updateLbl {textLbl} {
       .ftop.title configure -text $textLbl
    }   

    #-------------------------------------------------------------------------
    # Delegated procedures
    #-------------------------------------------------------------------------

    #-------------------------------------------------------------------------
    # Local procedures
    # {MLE-020418: Tcl/Tk goal should be to get rid of all local procedures, 
    # because they represent intelligence, which the display should not have.}
    #-------------------------------------------------------------------------
    # Local procedures
}
