##############################################################################
#
# vc/src/tcl/progress.tcl
#
# Progress screen
#
# 20080328 DEH - Created
#
# Copyright (c) 2008 Novariant inc
# All Rights Reserved. 
##############################################################################
namespace eval Screen { 

    #-------------------------------------------------------------------------
    # Define and pack the screen
    #-------------------------------------------------------------------------
    # All screens must create a top level frame .ftop and destroy it in sExit
    frame .ftop

    # Input Frame
    frame .ftop.input

    SnazzyButton::create .ftop.input.skip btnKhakiU btnKhakiD 0.5 \
        "beepOnce; post $DISP_BTN9_SIG 9" "Skip Survey"
#    pack .ftop.input.skip -side left -padx 5 -pady 5 -anchor sw

    # Display Frame
    frame .ftop.display
    label .ftop.display.l 
    pack .ftop.display.l -side top -pady 15

    # Survey progress frame
    frame .ftop.display.progress

    set barWidth 400
    set barHeight 20
    canvas .ftop.display.progress.bar -background $color6 \
            -width $barWidth -height $barHeight -relief sunken -borderwidth 2
    incr barHeight        
    .ftop.display.progress.bar create rectangle 0 0 0 $barHeight \
            -outline black -fill $colorMedium -tags gauge
    .ftop.display.progress.bar create text [expr $barWidth/2] 4 \
            -font $small_font -anchor nw -text "0%" -tags value
    pack .ftop.display.progress.bar -side bottom
    pack .ftop.display.progress -side bottom -expand yes -fill both

    # Pack the various elements
    pack .ftop.input -side bottom -fill both -expand yes -anchor s
    pack .ftop.display -side bottom -fill both -expand yes


    #-------------------------------------------------------------------------
    # Standard entry and exit procedures (called by GuiMgr)
    #-------------------------------------------------------------------------
    # Action called by GuiMgr on entry to this screen
    proc actEntry { title } {
        
        .ftop.display.l configure -text $title
        pack .ftop -fill both -expand yes
    }

    # Action called by GuiMgr on exit from this screen
    proc actExit {} {
        destroy .ftop
    }


    #-------------------------------------------------------------------------
    # Screen action procedures (to be called by GuiMgr)
    #-------------------------------------------------------------------------
    # Update procedures of this template can be called by the GuiMgr
    proc actProgress { percentComplete color } {
        .ftop.display.progress.bar itemconfigure gauge -fill $color
        .ftop.display.progress.bar itemconfigure value -text "$percentComplete%"

        .ftop.display.progress.bar coords gauge 1 1 \
             [expr 0.01*$percentComplete*$Screen::barWidth] $Screen::barHeight
    }

}
 
