##############################################################################
#
# vc/src/tcl/wizard.tcl
#
# typical wizard screen,
#
# 20080207 JDA - created
#
# Copyright (c) 2008 IntegriNautics Corporation.
# All Rights Reserved. 
##############################################################################
namespace eval wizardNavigation {

    frame .wizardNavigation -height $inputHeight -width $winWidth
    pack .wizardNavigation -side bottom -fill both -expand yes -anchor s
 
    # Exit Wizard button
    SnazzyButton::create .wizardNavigation.exit btnKhakiU btnKhakiD 0.2 \
                         "beepOnce; post $DISP_BTN9_SIG 9"
    # Input frame 
    frame .wizardNavigation.r1

    #Continue button
    SnazzyButton::create .wizardNavigation.r1.b0 btnKhakiU btnKhakiD 0.2 \
                         "beepOnce; post $DISP_BTN0_SIG 0"
    #Select button
    SnazzyButton::create .wizardNavigation.r1.b1 btnBlueU btnBlueD 0.25 \
                         "beepOnce; post $DISP_BTN1_SIG 1"
    #BACK button
    SnazzyButton::create .wizardNavigation.r1.b2 btnBlueU btnBlueD 0.25 \
                         "beepOnce; post $DISP_BTN2_SIG 2"

    pack .wizardNavigation.exit -side left -padx 5 -pady 5  -anchor sw

    pack .wizardNavigation.r1 -side bottom -anchor se
    pack .wizardNavigation.r1.b2 -side left -padx 5 -pady 5

    pack .wizardNavigation.r1.b0 -side right -padx 5 -pady 5
    pack .wizardNavigation.r1.b1 -side right -padx 5 -pady 5


    SnazzyButton::setText .wizardNavigation.exit "Return" 0.2
    SnazzyButton::setText .wizardNavigation.r1.b0 "Continue" 0.2
    SnazzyButton::setText .wizardNavigation.r1.b1 "Select" 0.25
    SnazzyButton::setText .wizardNavigation.r1.b2 "Back" 0.25
}

namespace eval Screen { 

    #-------------------------------------------------------------------------
    # Define and pack the screen
    #-------------------------------------------------------------------------
    # All screens must create a top level frame .ftop and destroy it on exit
    frame .ftopw

    # Define and pack the screen layout
    # (Screen has custom display and input frames
    # components) 

    frame .ftopw.display         ;# Display Frame
 
#    pack .wizardNavigation -in .ftopw -side bottom -anchor sw -padx 10 -pady 10
#    raise .wizardNavigation

    pack .ftopw.display -side bottom -fill both -expand yes

    pack .wizardTopDisplay -in .ftopw -side top -anchor nw -padx 10 -pady 10
    raise .wizardTopDisplay


    # Display Frame - displays up to 3 lines of text
    #label .ftopw.display.l0

  
    # Pack the display and input frames
#    pack .ftopw.display.l0 -side top -pady 5 -fill both -expand yes
 

    
    #-------------------------------------------------------------------------
    # Standard entry and exit procedures (called by GuiMgr)
    #-------------------------------------------------------------------------
    # Action called by GuiMgr on entry to this screen
    proc actEntry {title} {

#        .ftopw.display.l0 configure -text $title
        pack .$title -in .ftopw.display
#	raise .$title

         pack .ftopw -fill both -expand yes
    }

    proc actEntryNewScreen {title} {
        pack .$title -in .ftopw.display
	raise .$title
	pack .ftopw.display
    }

    proc actForgetScreen {title} {
        pack forget .$title
    }

    # Action called by GuiMgr on exit from this screen
    proc actExit {} {
        destroy .ftopw
    }


    #-------------------------------------------------------------------------
    # Screen action procedures (to be called by GuiMgr)
    #-------------------------------------------------------------------------

    #-------------------------------------------------------------------------
    # Delegated procedures
    #-------------------------------------------------------------------------

}
