##############################################################################
#
# sync/src/tcl/selectjob.tcl
#
# Screen to display selectjob selections
#
# RA - created
#
# Copyright (c) 2005 Novariant Corporation.
# All Rights Reserved. 
##############################################################################
namespace eval Screen { 

    # image create photo ExclamationPoint -format gif -file ExclamationPoint.gif

    # screen3 manual menu ........................................................
    frame .ftop -width 600 -height 455

    label .ftop.title -font $huge_font -width 250 \
	-text "Synchronize Jobs" -pady 10
    place .ftop.title -relx .5 -y 0 -anchor n

    image create photo btnBlueQuestionU -format gif -file \
	${tclPath}gif/btnBlueQuestionU.gif
    image create photo btnBlueQuestionD -format gif -file \
	${tclPath}gif/btnBlueQuestionD.gif

    SnazzyButton::create .ftop.help btnBlueQuestionU btnBlueQuestionD 0.5 \
                         "beepOnce; post $DISP_BTN0_SIG 0" ""

    place .ftop.help -relx 0.97 -y 5 -width 46 -height 46 -anchor ne

    frame .ftop.conflict -width 600 -height 400

    label .ftop.conflict.attention -font $big_font \
	-text "Resolving job issues related to base station "
    place .ftop.conflict.attention -relx .5 -y 10 -anchor n 

    label .ftop.conflict.title -font $medium_font -width 300 \
	-text "Touch the name of the next job you would\nlike to synchronize:"
    place .ftop.conflict.title -relx .5 -y 55 -anchor n

    label .ftop.conflict.allsynced -font $huge_font -width 300

    label .ftop.conflict.remoteLbl -text "On Your Sync Disk:" -font $medium_font 
    place .ftop.conflict.remoteLbl -relx 0.20 -y 90 -anchor n

    scrollbar .ftop.conflict.sbar1 -orient vertical \
	-command [list .ftop.conflict.remoteTxt yview] \
	-width 38 

    scrollbar .ftop.conflict.sbar2 -orient vertical \
	-command [list .ftop.conflict.localTxt yview] \
	-width 38

    listbox .ftop.conflict.remoteTxt -width 28 -height 16 -font $small_font \
	-exportselection 0 \
	-yscrollcommand [list .ftop.conflict.sbar1 set] \
	-background white -selectbackground gray

    place .ftop.conflict.sbar1 -relx 0.0 -y 110 -height 274   
    place .ftop.conflict.remoteTxt -relx 0.245 -y 110 -anchor n

    bind .ftop.conflict.remoteTxt <ButtonRelease-1> \
	{post $DISP_CANVAS1_SIG 1}

    label .ftop.conflict.localLbl -text "On Your GPS System:" -font $medium_font
    place .ftop.conflict.localLbl -relx 0.80 -y 90 -anchor n

    listbox .ftop.conflict.localTxt -width 28 -height 16 -font $small_font \
	-exportselection 0 \
	-yscrollcommand [list .ftop.conflict.sbar2 set] \
	-background white -selectbackground gray

    place .ftop.conflict.sbar2 -relx .925 -y 110 -height 274                             
    place .ftop.conflict.localTxt -relx 0.755 -y 110 -anchor n

    bind .ftop.conflict.localTxt <ButtonRelease-1> \
	{post $DISP_CANVAS0_SIG 0}

    SnazzyButton::create .ftop.conflict.toLocal btnBlueM2U btnBlueM2D \
	0.5 "beepOnce; post $DISP_BTN1_SIG 1" "Copy >>"

    SnazzyButton::create .ftop.conflict.toRemote btnBlueM2U btnBlueM2D \
	0.5 "beepOnce; post $DISP_BTN2_SIG 2" "<< Copy"

    SnazzyButton::create .ftop.conflict.delLocal btnBlueM2U btnBlueM2D \
	0.5 "beepOnce; post $DISP_BTN3_SIG 3" "Delete ->"

    SnazzyButton::create .ftop.conflict.delRemote btnBlueM2U btnBlueM2D \
	0.5 "beepOnce; post $DISP_BTN4_SIG 4" "<- Delete"

    SnazzyButton::create .ftop.conflict.viewLocal btnBlueM2U btnBlueM2D \
	0.5 "beepOnce; post $DISP_BTN5_SIG 5" "View ->"

    SnazzyButton::create .ftop.conflict.viewRemote btnBlueM2U btnBlueM2D \
	0.5 "beepOnce; post $DISP_BTN6_SIG 6" "<- View"

    SnazzyButton::create .ftop.conflict.viewData btnBlueM2U btnBlueM2D \
	0.5 "beepOnce; post $DISP_BTN7_SIG 7" "View\nData"
#    place .ftop.conflict.skip -relx 0.501 -y 245 -anchor n

    SnazzyButton::create .ftop.conflict.finished btnBlueM2U btnBlueM2D \
	0.5 "beepOnce; post $DISP_BTN8_SIG 8" "Finished"
    place .ftop.conflict.finished -relx 0.501 -y 320 -anchor n

    SnazzyButton::create .ftop.conflict.return btnBlueM2U btnBlueM2D \
	0.5 "beepOnce; post $DISP_BTN9_SIG 9" "Return"

    SnazzyButton::create .ftop.conflict.skip btnBlueM2U btnBlueM2D \
	0.5 "beepOnce; post $DISP_BTN9_SIG 9" "Skip"

    SnazzyButton::create .ftop.conflict.ok btnAcceptU btnAcceptD 0.3 \
	"beepOnce; post $DISP_BTN8_SIG 8" "Ok"

    #-------------------------------------------------------------------------
    # Standard entry and exit procedures (called by GuiMgr)
    #-------------------------------------------------------------------------
    # Action called by GuiMgr on entry to this screen
    proc actEntry {basename fieldname} {
	global huge_font color3

	.ftop.conflict.attention configure -text \
	    "Resolving job issues related to base station \"$basename\",\
\nfield \"$fieldname\""
	place .ftop.conflict -relx 0.04 -y 50
        pack .ftop -fill both -expand yes
    }


    # Action called by GuiMgr on exit from this screen
    proc actExit {} {
        destroy .ftop
    }

    #-------------------------------------------------------------------------
    # Screen action procedures (to be called by GuiMgr)
    #-------------------------------------------------------------------------

    proc actListboxInsert { where item } {
	#puts "selectJob -- insert $item"
	$where insert end $item
    }

    proc actListboxGetCurselection {where} {
	if { [$where index end] != 0} {
	    set index [$where curselection]
	    return [$where get $index]
	} else {
	    return "!"             ;# ! tells the C side the listbox was empty
	}
    }

    proc actListboxSetCurselection {where item} {
	$where selection clear 0 end
	$where selection set $item $item
    }

    proc actListboxClearCurselection {where} {
	$where selection clear 0 end
    }

    proc actButtonsLocal { entry } {
	puts "actButtonsLocal $entry"
	.ftop.conflict.title configure -text \
	    "$entry exists only on your GPS System"
	place .ftop.conflict.toRemote -relx 0.501 -y 95 -anchor n
	place forget .ftop.conflict.toLocal
	place .ftop.conflict.delLocal -relx 0.501 -y 170 -anchor n
	place forget .ftop.conflict.delRemote
	place .ftop.conflict.viewLocal -relx 0.501 -y 245 -anchor n
	place forget .ftop.conflict.viewRemote
	place forget .ftop.conflict.viewData
	place forget .ftop.conflict.return
	place .ftop.conflict.finished -relx 0.501 -y 320 -anchor n
    }

    proc actButtonsRemote { entry } {
	puts "actButtonsRemote $entry"
	.ftop.conflict.title configure -text \
	    "$entry exists only on your Sync Disk"
	place .ftop.conflict.toLocal -relx 0.501 -y 95 -anchor n
	place forget .ftop.conflict.toRemote
	place .ftop.conflict.delRemote -relx 0.501 -y 170 -anchor n
	place forget .ftop.conflict.delLocal
	place .ftop.conflict.viewRemote -relx 0.501 -y 245 -anchor n
	place forget .ftop.conflict.viewLocal
	place forget .ftop.conflict.viewData
	place forget .ftop.conflict.return
	place .ftop.conflict.finished -relx 0.501 -y 320 -anchor n
    }

    proc actButtonsInternalConflict { entry } {
	puts "actButtonsInternalConflict $entry"
	.ftop.conflict.title configure -text \
	    "Conflicting versions of $entry found"
	place .ftop.conflict.toLocal -relx 0.501 -y 95 -anchor n
	place forget .ftop.conflict.delRemote
	place .ftop.conflict.toRemote -relx 0.501 -y 170 -anchor n
	place forget .ftop.conflict.delLocal
	place .ftop.conflict.viewData -relx 0.501 -y 245 -anchor n
	place forget .ftop.conflict.viewLocal
	place forget .ftop.conflict.viewRemote
	place forget .ftop.conflict.return
	place .ftop.conflict.finished -relx 0.501 -y 320 -anchor n
    }

    proc actButtonsLocalView { entry } {
	puts "actButtonsLocal $entry"
	.ftop.conflict.title configure -text \
	    "$entry exists only on your GPS System"
	place forget .ftop.conflict.toLocal
	place forget .ftop.conflict.toRemote
	place forget .ftop.conflict.delLocal
	place forget .ftop.conflict.delRemote
	place forget .ftop.conflict.viewLocal
	place forget .ftop.conflict.viewRemote
	place forget .ftop.conflict.viewData
	place forget .ftop.conflict.finished
	place .ftop.conflict.return -relx 0.501 -y 320 -anchor n
    }

    proc actButtonsRemoteView { entry } {
	puts "actButtonsLocal $entry"
	.ftop.conflict.title configure -text \
	    "$entry exists only on your Sync Disk"
	place forget .ftop.conflict.toLocal
	place forget .ftop.conflict.toRemote
	place forget .ftop.conflict.delLocal
	place forget .ftop.conflict.delRemote
	place forget .ftop.conflict.viewLocal
	place forget .ftop.conflict.viewRemote
	place forget .ftop.conflict.viewData
	place forget .ftop.conflict.finished
	place .ftop.conflict.return -relx 0.501 -y 320 -anchor n
    }

    proc actButtonsConflictView { entry } {
	puts "actButtonsLocal $entry"
	.ftop.conflict.title configure -text \
	    "Conflicting versions of $entry found"
	place .ftop.conflict.toLocal -relx 0.501 -y 95 -anchor n
	place forget .ftop.conflict.delRemote
	place .ftop.conflict.toRemote -relx 0.501 -y 170 -anchor n
	place forget .ftop.conflict.delLocal
	place forget .ftop.conflict.delRemote
	place forget .ftop.conflict.viewLocal
	place forget .ftop.conflict.viewRemote
	place forget .ftop.conflict.viewData
	place forget .ftop.conflict.finished
	place .ftop.conflict.return -relx 0.501 -y 320 -anchor n
    }

    proc actButtonsConflictViewSkip { entry } {
	puts "actButtonsLocal $entry"
	.ftop.conflict.title configure -text \
	    "Conflicting versions of $entry found"
	place .ftop.conflict.toLocal -relx 0.501 -y 95 -anchor n
	place forget .ftop.conflict.delRemote
	place .ftop.conflict.toRemote -relx 0.501 -y 170 -anchor n
	place forget .ftop.conflict.delLocal
	place forget .ftop.conflict.delRemote
	place forget .ftop.conflict.viewLocal
	place forget .ftop.conflict.viewRemote
	place forget .ftop.conflict.viewData
	place forget .ftop.conflict.finished
	place .ftop.conflict.skip -relx 0.501 -y 320 -anchor n
    }

    proc actButtonsFinished {} {
	.ftop.conflict.title configure -text \
	    "Touch the name of the next job you would\nlike to synchronize:"
	place forget .ftop.conflict.toLocal
	place forget .ftop.conflict.toRemote
	place forget .ftop.conflict.delLocal
	place forget .ftop.conflict.delRemote
	place forget .ftop.conflict.viewLocal
	place forget .ftop.conflict.viewRemote
	place forget .ftop.conflict.viewData
	place forget .ftop.conflict.return
	place .ftop.conflict.finished -relx 0.501 -y 320 -anchor n
     }

    proc actClearListBoxes {} {
	.ftop.conflict.localTxt delete 0 end
	.ftop.conflict.remoteTxt delete 0 end
    }

    proc actAllSynced {fieldname basename} {
	global huge_font
	.ftop.conflict.allsynced configure -font $huge_font -text \
	    "The jobs for field $fieldname\nat base station $basename\nare completely synchronized."
	place .ftop.conflict.allsynced -relx .5 -y 90 -anchor n
	.ftop.conflict.attention configure -text  " "
	.ftop.conflict.title configure -text  " "
	place forget .ftop.conflict.toLocal
	place forget .ftop.conflict.toRemote
	place forget .ftop.conflict.delLocal
	place forget .ftop.conflict.delRemote
	place forget .ftop.conflict.viewLocal
	place forget .ftop.conflict.viewRemote
	place forget .ftop.conflict.viewData
	place forget .ftop.conflict.return
	place forget .ftop.conflict.finished 
	place forget .ftop.conflict.remoteTxt
	place forget .ftop.conflict.sbar1
	place forget .ftop.conflict.localTxt
	place forget .ftop.conflict.sbar2
	place forget .ftop.conflict.remoteLbl
	place forget .ftop.conflict.localLbl
	place forget .ftop.title
	place forget .ftop.help
	place .ftop.conflict.ok -relx 1.0 -y 400 -anchor se
    }

    proc actCopySuccess {typename entryname} {
	global medium_font
	.ftop.conflict.title configure -font $medium_font -text \
	    "$entryname successfully copied to $typename."
    }

    #-------------------------------------------------------------------------
    # Delegated procedures
    #-------------------------------------------------------------------------

    #-------------------------------------------------------------------------
    # Local procedures
    # {MLE-020418: Tcl/Tk goal should be to get rid of all local procedures, 
    # because they represent intelligence, which the display should not have.}
    #-------------------------------------------------------------------------
    # Local procedures
}
