##############################################################################
#
# vc/src/tcl/setstormmode3.tcl
#
# Main AutoFarm screen --- used for row lineup and AutoSteer modes.
#
# 20020411 MLE - created
#
# Copyright (c) 2002 IntegriNautics Corporation.
# All Rights Reserved. 
##############################################################################
namespace eval Screen { 
frame .ftop 
  label .ftop.title -text "Advanced GPS Settings" -bd 1 -relief solid -bg lightgray
  

label .ftop.help -text "Help" 

frame .ftop.content

frame .ftop.content.partialfix 

frame .ftop.content.partialfix.btn
    SnazzyButton::create .ftop.content.partialfix.btn.img btnGreenSliderDChecked \
      btnGreenSliderUChecked 0.5 "beepOnce;"
    label .ftop.content.partialfix.btn.txt -text "Use Partial Fix" -font $medium_font 


    pack .ftop.content.partialfix.btn.img -side left
    pack .ftop.content.partialfix.btn.txt -side right

 frame .ftop.content.partialfix.explain
 label .ftop.content.partialfix.explain.1 -text "Partial fix is an experimental\
 GPS mode that improves" -font $medium_font 
 label .ftop.content.partialfix.explain.2 -text "survey time and allows for\
 adjustments for weather" -font $medium_font 
 
 pack .ftop.content.partialfix.explain.1 -side top -anchor sw
 pack .ftop.content.partialfix.explain.2 -side bottom -anchor sw

 pack .ftop.content.partialfix.btn -side top -anchor sw
 pack .ftop.content.partialfix.explain -side bottom -padx 10 -anchor sw
  

   
frame .ftop.content.weathercondition

frame .ftop.content.weathercondition.sunny

   SnazzyButton::create .ftop.content.weathercondition.sunny.btn btnBlueS2U \
      btnBlueUChecked 0.5 "beepOnce; "

   label .ftop.content.weathercondition.sunny.explain -text "Use this button when weather is mild" \
                -font $medium_font
    
     pack .ftop.content.weathercondition.sunny.btn -side left
     pack .ftop.content.weathercondition.sunny.explain -side right -padx 15

   frame .ftop.content.weathercondition.storm
 

#frame .ftop.content.weathercondition.storm.btn
     SnazzyButton::create .ftop.content.weathercondition.storm.btn btnBlueS2U \
      btnBlueUChecked 0.5 "beepOnce; "

frame .ftop.content.weathercondition.storm.explain

         label .ftop.content.weathercondition.storm.explain.1 -text \
 "Use this button when there are dark storm" -font $medium_font
          label .ftop.content.weathercondition.storm.explain.2 -text \
 "clouds visible anywhere in the sky, or when" -font $medium_font
          label .ftop.content.weathercondition.storm.explain.3 -text \
"you know there is a storm system in the area" -font $medium_font
         
        #pack .ftop.content.weathercondition.storm
        #pack .ftop.content.weathercondition.storm.explain
         pack .ftop.content.weathercondition.storm.explain.1 -side top  -padx 15 -anchor sw
         pack .ftop.content.weathercondition.storm.explain.2 -side top -padx 15  -anchor sw
         pack .ftop.content.weathercondition.storm.explain.3 -side bottom -padx 15 -anchor sw

         pack .ftop.content.weathercondition.storm.btn -side left
         pack .ftop.content.weathercondition.storm.explain -side right

     #pack .ftop.content.weathercondition
     pack .ftop.content.weathercondition.sunny -side top   -anchor sw           
     pack .ftop.content.weathercondition.storm -side bottom -anchor sw
        
     #pack .ftop.content.content
#     pack .ftop.help -side top
     pack .ftop.content.partialfix -side top -anchor sw
     pack .ftop.content.weathercondition -side bottom -anchor sw


  frame .ftop.exit
    SnazzyButton::create .ftop.exit.cancel btnKhakiU btnKhakiD 0.5 \
                 "beepOnce; post $DISP_BTN9_SIG 9;" "Return To \n Previous \n Menu"

    pack .ftop.exit.cancel -side left
    

 # Pack .ftop
     pack .ftop.title -side top -fill both -expand yes
     pack .ftop.help -side top -padx 10
     pack .ftop.content -side top -padx 20 -expand yes
     pack .ftop.exit -side bottom -anchor se -fill both -expand yes
                 
    #-------------------------------------------------------------------------
    # Standard entry and exit procedures (called by GuiMgr)
    #-------------------------------------------------------------------------
    # Action called by GuiMgr on entry to this screen
proc actEntry {partialLbl sunnyLbl stormLbl returnBtn } {      
        .ftop.title configure -text "Advanced GPS Setting"      
      #SnazzyButton::setText .ftop.exit $returnBtn 0.5
      SnazzyButton::setText .ftop.content.weathercondition.sunny.btn $sunnyLbl 0.5  
      SnazzyButton::setText .ftop.content.weathercondition.storm.btn $stormLbl 0.5 

      pack .ftop -fill both -expand yes
}

    # Action called by GuiMgr on exit from this screen
    proc actExit {} {
        destroy .ftop
    }

}
