##############################################################################
#
# vc/src/tcl/signals.h.tcl
#
# Signals for the GUI Tk scripts
#
# 20020314 MLE and m_s - created
#
# Copyright (c) 2002 IntegriNautics Corporation.
# All Rights Reserved. 
##############################################################################

# Display Signals
# NOTE: DISP_START_SIG must be set externally prior to sourcing this script
set DISP_READY_SIG [expr $DISP_START_SIG + 0]
set DISP_ERROR_SIG [expr $DISP_START_SIG + 1]
set DISP_EXIT_SIG  [expr $DISP_START_SIG + 2]

# button signals
set DISP_BTN0_SIG     [expr $DISP_START_SIG + 3]   ;# common offset of buttons
set DISP_BTN1_SIG     [expr $DISP_START_SIG + 4]
set DISP_BTN2_SIG     [expr $DISP_START_SIG + 5]
set DISP_BTN3_SIG     [expr $DISP_START_SIG + 6]
set DISP_BTN4_SIG     [expr $DISP_START_SIG + 7]
set DISP_BTN5_SIG     [expr $DISP_START_SIG + 8]
set DISP_BTN6_SIG     [expr $DISP_START_SIG + 9]
set DISP_BTN7_SIG     [expr $DISP_START_SIG + 10]
set DISP_BTN8_SIG     [expr $DISP_START_SIG + 11]
set DISP_BTN9_SIG     [expr $DISP_START_SIG + 12]
set DISP_BTN_MAX_SIG  [expr $DISP_START_SIG + 13]   ;#not a legitimate signal!

# slider signals
set DISP_SLDR0_SIG    [expr $DISP_START_SIG + 14]  ;# common offset of sliders
set DISP_SLDR1_SIG    [expr $DISP_START_SIG + 15]
set DISP_SLDR2_SIG    [expr $DISP_START_SIG + 16]
set DISP_SLDR3_SIG    [expr $DISP_START_SIG + 17]
set DISP_SLDR4_SIG    [expr $DISP_START_SIG + 18]
set DISP_SLDR5_SIG    [expr $DISP_START_SIG + 19]
set DISP_SLDR6_SIG    [expr $DISP_START_SIG + 20]
set DISP_SLDR7_SIG    [expr $DISP_START_SIG + 21]
set DISP_SLDR8_SIG    [expr $DISP_START_SIG + 22]
set DISP_SLDR9_SIG    [expr $DISP_START_SIG + 23]
set DISP_SLDR_MAX_SIG [expr $DISP_START_SIG + 24]   ;#not a legitimate signal!

# canvas signals
set DISP_CANVAS0_SIG    [expr $DISP_START_SIG + 25]           ;# common offset
set DISP_CANVAS1_SIG    [expr $DISP_START_SIG + 26]
set DISP_CANVAS2_SIG    [expr $DISP_START_SIG + 27]
set DISP_CANVAS3_SIG    [expr $DISP_START_SIG + 28]
set DISP_CANVAS4_SIG    [expr $DISP_START_SIG + 29]
set DISP_CANVAS5_SIG    [expr $DISP_START_SIG + 30]
set DISP_CANVAS6_SIG    [expr $DISP_START_SIG + 31]
set DISP_CANVAS7_SIG    [expr $DISP_START_SIG + 32]
set DISP_CANVAS_MAX_SIG [expr $DISP_START_SIG + 33] ;#not a legitimate signal!

#listbox
set DISP_LISTBOXSELECT0_SIG    [expr $DISP_START_SIG + 34]
set DISP_LISTBOX_MAX_SIG [expr $DISP_START_SIG + 35] ;#not a legitimate signal!


# logo signals
set DISP_LOGO1_SIG [expr $DISP_START_SIG + 36] ;#not a legitimate signal!
set DISP_LOGO_MAX_SIG [expr $DISP_START_SIG + 37] ;#not a legitimate signal!

# checkbutton signals
set DISP_CKBTN0_SIG     [expr $DISP_START_SIG + 38]
set DISP_CKBTN1_SIG     [expr $DISP_START_SIG + 39]
set DISP_CKBTN2_SIG     [expr $DISP_START_SIG + 40]
set DISP_CKBTN3_SIG     [expr $DISP_START_SIG + 41]
set DISP_CKBTN4_SIG     [expr $DISP_START_SIG + 42]
set DISP_CKBTN_MAX_SIG [expr $DISP_START_SIG + 43] ;#not a legitimate signal!

# wizard signals
set DISP_WIZARD_CONTINUE_SIG [expr $DISP_START_SIG + 44]
set DISP_WIZARD_SELECT_SIG   [expr $DISP_START_SIG + 45]
set DISP_WIZARD_BACK_SIG     [expr $DISP_START_SIG + 46]
set DISP_WIZARD_EXIT_SIG     [expr $DISP_START_SIG + 47]
set DISP_WIZARD_HELP_SIG     [expr $DISP_START_SIG + 48]
set DISP_WIZARD_HELPRET_SIG  [expr $DISP_START_SIG + 49]
set DISP_WIZARD_HELPMORE_SIG [expr $DISP_START_SIG + 50]
set DISP_WIZARD_HELPBACK_SIG [expr $DISP_START_SIG + 51]
set DISP_WIZARD_LISTBOX0_SIG [expr $DISP_START_SIG + 52]
set DISP_WIZARD_LISTBOX1_SIG [expr $DISP_START_SIG + 53]
set DISP_WIZARD_STOP_SIG     [expr $DISP_START_SIG + 54]
set DISP_WIZARD_NUDGE_LEFT_SIG   [expr $DISP_START_SIG + 55]
set DISP_WIZARD_NUDGE_RIGHT_SIG  [expr $DISP_START_SIG + 56]
set DISP_WIZARD_TOGGLE_STEERING_RSP_SIG [expr $DISP_START_SIG + 57]
set DISP_WIZARD_FIND_STEERING_RSP_SIG  [expr $DISP_START_SIG + 58]
set DISP_WIZARD_TOGGLE_COULTER_RSP_SIG [expr $DISP_START_SIG + 59]
# other widget signals follow...
