##############################################################################
#
# sync/src/tcl/syncmgr.tcl
#
# Screen to display syncmgr selections
#
# RA - created
#
# Copyright (c) 2005 Novariant Corporation.
# All Rights Reserved. 
##############################################################################
namespace eval Screen { 

    #-------------------------------------------------------------------------
    # Define and pack the screen
    #-------------------------------------------------------------------------
    # All screens must create a top level frame .ftop and destroy it on exit
    frame .ftop
    frame .ftop.display         ;# Display Frame
    frame .ftop.header
    frame .ftop.input           ;# Input Frame
    frame .ftop.header.help
    frame .ftop.display.leftspace
    frame .ftop.display.left
    frame .ftop.display.right
    frame .ftop.display.left.base
    frame .ftop.display.left.field
    frame .ftop.display.left.job
    frame .ftop.display.right.implement
    frame .ftop.display.right.vehicle
    frame .ftop.display.right.space -height 50

    pack .ftop.input -side bottom -padx 0
    pack .ftop.header -side top -expand yes -fill x -anchor n
    pack .ftop.display -side top -padx 5
    pack .ftop.display.leftspace -side left -anchor e -padx 50
    pack .ftop.display.left -side left -anchor e -pady 30
    pack .ftop.display.right -side right -padx 90 -pady 30

    frame .ftop.header.left -width 150
    pack .ftop.header.left -side left
    frame .ftop.header.center
    pack .ftop.header.center -side left -padx 10
    pack .ftop.header.help -side right -expand yes -fill both

    label .ftop.header.center.l0 -text "line 0"
    pack .ftop.header.center.l0 -side top -pady 15

    label .ftop.header.center.l1 -text "Select the types of data to synchronize:" \
	-font $large_font -pady 10

    image create photo checkboxD1 \
            -format gif \
            -file ${tclPath}gif/btnGreenSliderUChecked.gif

    image create photo checkboxU1 \
            -format gif \
            -file ${tclPath}gif/btnGreenSliderDChecked.gif

    SnazzyButton::create .ftop.display.left.base.btn checkboxU1 checkboxD1 0.5 \
	"beepOnce; post $DISP_CKBTN0_SIG 0" " "
    label .ftop.display.left.base.label -text "Base Stations" -font $large_font \
	-anchor e

    canvas .ftop.display.left.field.c1 -width 35 -height 36
    .ftop.display.left.field.c1 create line 15 0 15 25 35 25 -width 2

    canvas .ftop.display.left.job.c2 -width 70 -height 30
    .ftop.display.left.job.c2 create line 52 0 52 20 70 20 -width 2

    SnazzyButton::create .ftop.display.left.field.btn checkboxU1 checkboxD1 \
	0.5 "beepOnce; post $DISP_CKBTN1_SIG 1" " "

    label .ftop.display.left.field.label -text "Fields" -font $large_font

    SnazzyButton::create .ftop.display.left.job.btn checkboxU1 checkboxD1 0.5 \
	"beepOnce; post $DISP_CKBTN2_SIG 2" " "
    label .ftop.display.left.job.label -text "Jobs" -font $large_font

    SnazzyButton::create .ftop.display.right.implement.btn checkboxU1 checkboxD1 \
	0.5 "beepOnce; post $DISP_CKBTN3_SIG 3" " "
    label .ftop.display.right.implement.label -text "Implements" -font $large_font

    SnazzyButton::create .ftop.display.right.vehicle.btn checkboxU1 checkboxD1 \
	0.5 "beepOnce; post $DISP_CKBTN4_SIG 4" " "
    label .ftop.display.right.vehicle.label -text "Vehicles" -font $large_font

    image create photo btnBlueQuestionU -format gif -file \
	${tclPath}gif/btnBlueQuestionU.gif
    image create photo btnBlueQuestionD -format gif -file \
	${tclPath}gif/btnBlueQuestionD.gif

    SnazzyButton::create .ftop.header.help.b0 btnBlueQuestionU btnBlueQuestionD 0.5 \
                         "beepOnce; post $DISP_BTN0_SIG 0" ""

    SnazzyButton::create .ftop.input.exit btnKhakiU btnKhakiD 0.2 \
                         "beepOnce; post $DISP_BTN4_SIG 4" "Return to\nTools\nMenu"

    frame .ftop.input.space
    frame .ftop.input.r2
    SnazzyButton::create .ftop.input.r2.b1 btnBlueU btnBlueD 0.5 \
                         "beepOnce; post $DISP_BTN1_SIG 1" "Upgrade"
    SnazzyButton::create .ftop.input.r2.b2 btnBlueU btnBlueD 0.5 \
                         "beepOnce; post $DISP_BTN2_SIG 2" "Backup"
    SnazzyButton::create .ftop.input.r2.b3 btnBlueU btnBlueD 0.2 \
                         "beepOnce; post $DISP_BTN3_SIG 3" "Erase Sync\nDisk"

    pack .ftop.header.center.l1 -anchor w -side top
    pack .ftop.display.right.implement -anchor w -side top -pady 5
    pack .ftop.display.right.vehicle -anchor w -side top -pady 5
    pack .ftop.display.right.space -anchor w -side top -pady 5
    pack .ftop.display.left.base -anchor w -side top
    pack .ftop.display.left.field.c1 -anchor n -side left
    pack .ftop.display.left.field -anchor w -side top
    pack .ftop.display.left.job.c2 -anchor n -side left
    pack .ftop.display.left.job -anchor w -side top

    pack .ftop.display.left.base.label -side right
    pack .ftop.display.left.field.label -side right
    pack .ftop.display.left.job.label -side right
    pack .ftop.display.right.implement.label -side right
    pack .ftop.display.right.vehicle.label -side right
    pack .ftop.display.left.base.btn -side left
    pack .ftop.display.left.field.btn -side left -anchor s -pady 10
    pack .ftop.display.left.job.btn -side left -pady 5
    pack .ftop.display.right.implement.btn -side left -padx 2
    pack .ftop.display.right.vehicle.btn -side left -padx 2

    #-------------------------------------------------------------------------
    # Standard entry and exit procedures (called by GuiMgr)
    #-------------------------------------------------------------------------
    # Action called by GuiMgr on entry to this screen
    proc actEntry {sysLbl sysLbl1 base field job imp veh
		   btnFull btnUpgrade btnBackup btnExit} {
	global huge_font color3

	.ftop.header.center.l0 configure -text $sysLbl -font $huge_font
	.ftop.header.center.l1 configure -text $sysLbl1
	.ftop.display.left.base.label configure -text $base
	.ftop.display.left.field.label configure -text $field
	.ftop.display.left.job.label configure -text $job
	.ftop.display.right.implement.label configure -text $imp
	.ftop.display.right.vehicle.label configure -text $veh

        if {$btnExit != "!"} {
	  SnazzyButton::setText .ftop.input.exit $btnExit 0.5
          pack .ftop.input.exit -side left -pady 5 -anchor sw
        }
	.ftop.header.help.b0 configure -text "  "
	pack .ftop.header.help.b0 -side right -anchor nw -padx 2
        if {$btnFull != "!"} {
	    SnazzyButton::setText .ftop.input.r2.b3 $btnFull 0.5
	    pack .ftop.input.r2.b3 -side right -padx 0 -pady 5 -anchor se
        }
        if {$btnBackup != "!"} {
	  SnazzyButton::setText .ftop.input.r2.b2 $btnBackup 0.5
          pack .ftop.input.r2.b2 -side right -padx 0 -pady 5 -anchor se 
        }
        if {$btnUpgrade != "!"} {
	  SnazzyButton::setText .ftop.input.r2.b1 $btnUpgrade 0.5
          pack .ftop.input.r2.b1 -side right -padx 0 -pady 5 -anchor se 
        }
        
        pack .ftop.input.space -side left -anchor se -padx 94
        pack .ftop.input.r2 -side right -anchor w
	pack .ftop.header.center.l0 -side top -pady 5
        pack .ftop -fill both -expand yes

    }


    # Action called by GuiMgr on exit from this screen
    proc actExit {} {
        destroy .ftop
    }

    #-------------------------------------------------------------------------
    # Screen action procedures (to be called by GuiMgr)
    #-------------------------------------------------------------------------

    proc actPushbutton {buttonName img} {
	SnazzyButton::setImage $buttonName $img checkboxD1 0.5
    }

    #-------------------------------------------------------------------------
    # Delegated procedures
    #-------------------------------------------------------------------------

    #-------------------------------------------------------------------------
    # Local procedures
    # {MLE-020418: Tcl/Tk goal should be to get rid of all local procedures, 
    # because they represent intelligence, which the display should not have.}
    #-------------------------------------------------------------------------
    # Local procedures
}
