##############################################################################
#
# fsm.tcl utility (Finite State Machine with entry/exit actions)
#
# Copyright (c) 2003 IntegriNautics Corporation.
# All Rights Reserved. 
##############################################################################

proc FSM:tran { target } {
    global theState
    puts "tran to $target"
    eval {$theState EXIT ""}
    set theState $target
    eval {$theState ENTRY ""}
}

proc FSM:init { target } {
    global theState
    puts "init $target"
    set theState $target
    eval {$theState ENTRY ""}
}

proc FSM:dispatch { sig {data ""}} {
    global theState
    puts "dispatch $sig $data"
    eval {$theState $sig $data}
}

proc FSM:getState {} {
    global theState
    return $theState
}

