//////////////////////////////////////////////////////////////////////////////
//
// vcutils/syncdisk/usertcl.cpp
//
// 
//
// 20040324 MLE - created
//
// Copyright (c) 2002 IntegriNautics Corporation.
// All Rights Reserved. 
//////////////////////////////////////////////////////////////////////////////
#include <string.h>
#include <tk.h>

#include "vcport.h"
#include "qassert.h"
DEFINE_THIS_FILE;

#include "mvlib.h"

// MLE-040325: Clean these up...
//#include "vcmgrifc.h"
//#include "tractornav.h"
#include "dbmgrifc.h"
#include "guimgrifc.h"
//#include "diagmgrifc.h"
//#include "rxpreproc.h"
#include "cpfifc.h"
//#include "utility.h"
//#include "simple1.h"
#include "units.h"
#include "user.h"
//#include "steer.h"
//#include "meas.h"
//#include "language.h"
//#include "pkg.h"


f64 p_[KN_PAR] = {0};    // MLE-040325: Note .cpf parameters will not actually
                                                        // be available here!!
char const **theText;             // MLE-040325: points to nowhere; fragile!!!


extern "C" void onAssertWithReason__(char const *file,
                                     unsigned line,
                                     char const *reasonStr) {
  fprintf(stderr, "Assertion failed in %s, line %d, reason %s\n",
          file, line, reasonStr);
  fflush(stderr);
}


extern "C" void onAssert__(char const *file, unsigned line) {
  onAssertWithReason__(file, line, NULL);
}


int implementCompare(ClientData clientData__,
                     Tcl_Interp *interp__,
                     int argc__,
                     const char **argv__) {
  static Implement imp1();
  static Implement imp2();

  if (argc__ != 3) {
    interp__->result = "Wrong number of args";
    return TCL_ERROR;
  }

  

  if (strcmp(argv__[1], argv__[2]) == 0) {
    sprintf(interp__->result, "equal");
  }
  else {
    sprintf(interp__->result, "unequal");
  }
  return TCL_OK;
}


int jobCompare(ClientData clientData__,
               Tcl_Interp *interp__,
               int argc__,
               const char **argv__) {
  static GenericJob job1(p_);
  static GenericJob job2(p_);

  if (argc__ != 3) {
    interp__->result = "Wrong number of args";
    return TCL_ERROR;
  }

  if (strcmp(argv__[1], argv__[2]) == 0) {
    sprintf(interp__->result, "equal");
  }
  else {
    sprintf(interp__->result, "unequal");
  }
  return TCL_OK;
}


extern "C" {
  int User_Init(Tcl_Interp *interp__);
}


int User_Init(Tcl_Interp *interp__) {
  Tcl_CreateCommand(interp__, "jobCompare", &jobCompare,
                    (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL);
  Tcl_PkgProvide(interp__, "user", "1.1");
  return TCL_OK;
}







//============================================================================
// Implement
//============================================================================
void Implement::format(char *buf) {}
void Implement::name(const char *name__) {}
void Implement::type(const int type__) {}
void Implement::width(const f64 width__, Units widthUnits__) {}
void Implement::offset(const f64 offset__, Units offsetUnits__) {}
void Implement::adjustOffset(const f64 correction, Units correctionUnits) {}
void Implement::dbEncode(DbUpdateEvt * e__) {}
void Implement::dbUpgrade() {}
void Implement::fillVehicleDispData(GuiVehicleDispDataEvt* e__) {}

//============================================================================
// Tractor
//============================================================================
void Tractor::format(char *buf) {}
void Tractor::setName(const char *name) {}
void Tractor::setType(int const type, int const subtype) {}
void Tractor::setColor(const int color) {}
void Tractor::dbEncode(DbUpdateEvt *e) {}
void Tractor::dbUpgrade() {}

//============================================================================
// BaseStation
//============================================================================
void BaseStation::name(const char *name__) {}
void BaseStation::lat(const f64 lat__) {}
void BaseStation::lon(const f64 lon__) {}
void BaseStation::alt(const f64 alt__) {}
void BaseStation::lla(GuiGPSDataEvt const * e__) {}
void BaseStation::dbEncode(DbUpdateEvt * e__) {}
void BaseStation::dbUpgrade() {}
Bool BaseStation::nearby(const f64 *ecef__) {return False;}
void BaseStation::format(char *buf) {}

//============================================================================
// Field
//============================================================================
void Field::setFullName(char const *prefix, char const *name) {}
int Field::getNpoints() {return nPoints_;}
void Field::dbEncode(QActive *recipient, 
                     QSignal sigAdd, QSignal sigRepl, QSignal sigError) {}
void Field::dbUpgrade() {}
Bool Field::objectValid() {return False;}
void Field::format(char *buf, Units areaUnit__) {}
Bool Field::addPoint(f64 north, f64 east) {return False;}
Bool Field::isPointInField(f64 r_P_B__B2[3]) {return False;}
int Field::getStatus(f64 r_P_B__B2[3], f64 r_PP_B__B2[3]) {return NO_BOUNDARY;}
void Field::setArea() {}
void Field::fillVehicleDispData(GuiVehicleDispDataEvt* e__) {}

//****************************************************************************
// Jobs
//****************************************************************************
//============================================================================
// Job
//============================================================================
void Job::setFullName(char const *prefix, char const *name) {}
void Job::repeatSourceName(char const *name) {}
char const * Job::fullRepeatSourceName() {
  static char buf[3*MAX_NAME_SIZE + 2];
  strcpy(buf, fullName_);
  strcpy(buf + nameIndex_, repeatSourceName_);
  return buf;
}
void Job::setFlags(u32 flags__) {}
void Job::unsetFlags(u32 flags__) {}
void Job::mode(u32 mode__) {}
void Job::publishFlags() {}
void Job::onJobFlagsEvt(const JobFlagsEvt* e__) {}
void Job::dbEncode(DbUpdateEvt *e) {}
void Job::dbUpgrade() {}
void Job::largeNudge(f64 nudge, Units u) {}
void Job::nudgeRowRight(f64 nudge) {}
void Job::fillVehicleDispData(GuiVehicleDispDataEvt* e__) {}
void Job::setMark(const f64* r_P_B__B2__) {}
Bool Job::checkMark(const f64* r_P_B__B2__,
                    const f64* euler321__,
                    MarkData* mark__) {return False;}
Bool Job::checkSurveyMark(const f64* r_P_B__B2__,
                          const f64* euler321__,
                          MarkData* mark__) {return False;}

//============================================================================
// GenericJob
//============================================================================


//============================================================================
// StraightJob
//============================================================================
Bool StraightJob::objectValid() {return False;}
void StraightJob::setStart(f64* r_I_B__B2__) {}
Status StraightJob::setRowDir(f64* r_I_B__B2__) {return Error;}
void StraightJob::setRowDir(f64 yaw__) {}
void StraightJob::onJobRowDirEvt(const JobRowDirEvt* e__) {}
void StraightJob::format(char *buf) {}
void StraightJob::dbEncode(DbUpdateEvt *e) {}
void StraightJob::calcFloatingRowError(const f64* r_P_B__B2__,
                                       const f64* r_C_B__B2__,
                                       const f64* r_I_B__B2__,
                                       const f64* r_F_B__B2__,
                                       const f64* euler321__,
                                       const f64& implWidth__,
                                       f64& headingWrtRowDir__,
                                       f64& headingError__,
                                       f64& y_P_frozenRow__R__,
                                       f64& y_C_frozenRow__R__,
                                       f64& y_I_frozenRow__R__,
                                       f64& y_F_frozenRow__R__,
                                       f64* r_P_B__R__) {}
void StraightJob::calcFixedRowError(const f64* r_P_B__B2__,
                                    const f64* r_C_B__B2__,
                                    const f64* r_I_B__B2__,
                                    const f64* r_F_B__B2__,
                                    const f64* euler321__,
                                    const f64& implWidth__,
                                    f64& headingWrtRowDir__,
                                    f64& headingError__,
                                    f64& y_P_frozenRow__R__,
                                    f64& y_C_frozenRow__R__,
                                    f64& y_I_frozenRow__R__,
                                    f64& y_F_frozenRow__R__,
                                    f64* r_P_B__R__) {}
void StraightJob::freezeRow(const f64* r_P_B__B2__,
                            const f64& yaw__,
                            const f64& implWidth__) {}
f64 StraightJob::calcLateralError(const f64* r_P_B__B2__) const {return 0.0;}
f64 T_P_R[3][3];
void StraightJob::calc3DHeading(const f64* euler321__,
                                f64& headingWrtRowDir__,
                                f64& headingError__) {}
f64 StraightJob::calc3DLateralError(const f64* euler321__,
                                    const f64* r_P_B__B2__) const {
  return 0.0;
}
void StraightJob::publishRowDir() {}
void StraightJob::publishFrozenRowAndWarnings() {}

//============================================================================
// FanJob
//============================================================================
Bool FanJob::objectValid() {return False;}
void FanJob::currRow(int currRow__) {}
Status FanJob::incCurrRow() {return Error;}
void FanJob::setStart(f64* r_I_B__B2__) {}
Status FanJob::setRowDir(f64* r_I_B__B2__) {return Error;}
void FanJob::setRowDir(f64 yaw__) {}
void FanJob::setSpacing(f64 spacing__, Units u__) {}
void FanJob::incSpacing() {}
void FanJob::decSpacing() {}
void FanJob::format(char *buf) {}
void FanJob::dbEncode(DbUpdateEvt *e) {}
void FanJob::fillVehicleDispData(GuiVehicleDispDataEvt* e__) {}
Status FanJob::checkDefiningRows() {return Error;}
void FanJob::calcFloatingRowError(const f64* r_P_B__B2__,
                                  const f64* r_C_B__B2__,
                                  const f64* r_I_B__B2__,
                                  const f64* r_F_B__B2__,
                                  const f64* euler321__,
                                  const f64& implWidth__,
                                  f64& headingWrtRowDir__,
                                  f64& headingError__,
                                  f64& y_P_frozenRow__R__,
                                  f64& y_C_frozenRow__R__,
                                  f64& y_I_frozenRow__R__,
                                  f64& y_F_frozenRow__R__,
                                  f64* r_P_B__R__) {}
void FanJob::calcFixedRowError(const f64* r_P_B__B2__,
                               const f64* r_C_B__B2__,
                               const f64* r_I_B__B2__,
                               const f64* r_F_B__B2__,
                               const f64* euler321__,
                               const f64& implWidth__,
                               f64& headingWrtRowDir__,
                               f64& headingError__,
                               f64& y_P_frozenRow__R__,
                               f64& y_C_frozenRow__R__,
                               f64& y_I_frozenRow__R__,
                               f64& y_F_frozenRow__R__,
                               f64* r_P_B__R__) {}
void FanJob::freezeRow(const f64* r_P_B__B2__,
                       const f64& yaw__,
                       const f64& implWidth__) {}
f64 FanJob::calcLateralError(const f64* r_P_B__B2__) const {return 0.0;}
void FanJob::calcNRows(f64 spacing__) {}
void FanJob::calcAngleAndDistBtnRows(const f64* r_P_B__B2__,
                                     const f64& yaw__) {}

//============================================================================
// BoxJob
//============================================================================
Bool BoxJob::objectValid() {return False;}
void BoxJob::currRow(int currRow__) {}
Status BoxJob::incCurrRow() {return Error;}
void BoxJob::setStart(f64* r_I_B__B2__) {}
Status BoxJob::setRowDir(f64* r_I_B__B2__) {return Error;}
void BoxJob::setRowDir(f64 yaw__) {}
void BoxJob::format(char *buf) {}
void BoxJob::dbEncode(DbUpdateEvt *e) {}
void BoxJob::calcFloatingRowError(const f64* r_P_B__B2__,
                                  const f64* r_C_B__B2__,
                                  const f64* r_I_B__B2__,
                                  const f64* r_F_B__B2__,
                                  const f64* euler321__,
                                  const f64& implWidth__,
                                  f64& headingWrtRowDir__,
                                  f64& headingError__,
                                  f64& y_P_frozenRow__R__,
                                  f64& y_C_frozenRow__R__,
                                  f64& y_I_frozenRow__R__,
                                  f64& y_F_frozenRow__R__,
                                  f64* r_P_B__R__) {}
void BoxJob::calcFixedRowError(const f64* r_P_B__B2__,
                               const f64* r_C_B__B2__,
                               const f64* r_I_B__B2__,
                               const f64* r_F_B__B2__,
                               const f64* euler321__,
                               const f64& implWidth__,
                               f64& headingWrtRowDir__,
                               f64& headingError__,
                               f64& y_P_frozenRow__R__,
                               f64& y_C_frozenRow__R__,
                               f64& y_I_frozenRow__R__,
                               f64& y_F_frozenRow__R__,
                               f64* r_P_B__R__) {}
void BoxJob::findClosestRow(const f64 &yaw__) {}
void BoxJob::freezeRow(const f64* r_P_B__B2__,
                       const f64& yaw__,
                       const f64& implWidth__) {}
f64 BoxJob::calcLateralError(const f64* r_P_B__B2__) const {return 0.0;}

//============================================================================
// CircleJob
//============================================================================
Bool CircleJob::objectValid() {return False;}
void CircleJob::format(char *buf) {}
void CircleJob::dbEncode(DbUpdateEvt *e) {}
void CircleJob::beginCircleRowData(const f64* r_I_B__B2__) {}
void CircleJob::addCircleRowData(const f64* r_I_B__B2__) {}
Status CircleJob::endCircleRowData() {return Error;}
void CircleJob::nudgeRowRight(f64 nudge) {}
void CircleJob::calcFloatingRowError(const f64* r_P_B__B2__,
                                     const f64* r_C_B__B2__,
                                     const f64* r_I_B__B2__,
                                     const f64* r_F_B__B2__,
                                     const f64* euler321__,
                                     const f64& implWidth__,
                                     f64& headingWrtRowDir__,
                                     f64& headingError__,
                                     f64& y_P_frozenRow__R__,
                                     f64& y_C_frozenRow__R__,
                                     f64& y_I_frozenRow__R__,
                                     f64& y_F_frozenRow__R__,
                                     f64* r_P_B__R__) {}
void CircleJob::calcFixedRowError(const f64* r_P_B__B2__,
                                  const f64* r_C_B__B2__,
                                  const f64* r_I_B__B2__,
                                  const f64* r_F_B__B2__,
                                  const f64* euler321__,
                                  const f64& implWidth__,
                                  f64& headingWrtRowDir__,
                                  f64& headingError__,
                                  f64& y_P_frozenRow__R__,
                                  f64& y_C_frozenRow__R__,
                                  f64& y_I_frozenRow__R__,
                                  f64& y_F_frozenRow__R__,
                                  f64* r_P_B__R__) {}
void CircleJob::freezeRow(const f64* r_P_B__B2__,
                          const f64& yaw__,
                          const f64& implWidth__) {}

//============================================================================
// CurveJob
//============================================================================
Bool CurveJob::objectValid() {return False;}
Bool CurveJob::ok2AutoSteer() const {return False;}
void CurveJob::format(char *buf) {}
void CurveJob::dbEncode(DbUpdateEvt *e) {}
void CurveJob::onCurveDataBeginScRowEvt() {}
void CurveJob::onCurveDataScRowEvt(const CurveDataVcRowEvt * e__) {}
void CurveJob::onCurveDataEndScRowEvt() {}
void CurveJob::onCurveDataCcRowEvt(const CurveDataVcRowEvt * e__) {}
void CurveJob::nudgeRowRight(f64 nudge) {}
void CurveJob::calcFloatingRowError(const f64* r_P_B__B2__,
                                    const f64* r_C_B__B2__,
                                    const f64* r_I_B__B2__,
                                    const f64* r_F_B__B2__,
                                    const f64* euler321__,
                                    const f64& implWidth__,
                                    f64& headingWrtRowDir__,
                                    f64& headingError__,
                                    f64& y_P_frozenRow__R__,
                                    f64& y_C_frozenRow__R__,
                                    f64& y_I_frozenRow__R__,
                                    f64& y_F_frozenRow__R__,
                                    f64* r_P_B__R__) {}
void CurveJob::calcFixedRowError(const f64* r_P_B__B2__,
                                 const f64* r_C_B__B2__,
                                 const f64* r_I_B__B2__,
                                 const f64* r_F_B__B2__,
                                 const f64* euler321__,
                                 const f64& implWidth__,
                                 f64& headingWrtRowDir__,
                                 f64& headingError__,
                                 f64& y_P_frozenRow__R__,
                                 f64& y_C_frozenRow__R__,
                                 f64& y_I_frozenRow__R__,
                                 f64& y_F_frozenRow__R__,
                                 f64* r_P_B__R__) {}
void CurveJob::freezeRow(const f64* r_P_B__B2__,
                         const f64& yaw__,
                         const f64& implWidth__) {}
void CurveJob::findCurrentSegment(const f64* r_P_B__B2__,
                                  const f64& maxOnlineDist__,
                                  const f64& maxCloseDist__,
                                  int& dirn__,
                                  const f64& implWidth__) {}
void CurveJob::propagateFrozenRow(int dirn__, const f64& implWidth__) {}
void CurveJob::findUnitVectorsOnBspline(const f64* r_P_B__B2__) {}
f64 CurveJob::calcLateralError(const f64* r_P_B__B2__) const {return 0.0;}
void CurveJob::publishFrozenRowAndWarnings() {}

//============================================================================
// UserConfig
//============================================================================
void UserConfig::preNVDataInit() {}
void UserConfig::postNVDataInit() {}

//============================================================================
// Misc others
//============================================================================
void diagnostics(char *fmt, ...) {}
