#!/bin/sh

# Change splash screen: called from mavericks application.  This is called
# whenever the splash screen (initial boot screen) has to change.  Used
# only for A5.

# check number of arguments

if [ $# != 1 ]; then
   echo "Usage: changeSplash newSpashScreen"
   exit;
fi

LOGO=${1}

cd /mnt/splashScreen

# Make path absolute

SCRIPT_BASE=$(pwd)

. ./boot_functions

# Read in fancy output functions
. ./output.sh

export PATH=$PATH:$BINARY_PATH

##############################################################################

echo Logo: $LOGO

if test -e ./$LOGO
then
	diff_files $DIFF $LOGO_PART ./$LOGO
	if [ "$?" -eq 0 ] 
	then
		echo "Splash is up to date"
	else
		update_flash $LOGO $LOGO_PART
		test_result
	fi
else
        echo "Could not find Splash"
fi

##############################################################################

