##############################################################################
#
# vc/src/tcl/upgradeComplete.tcl
#
# 20050323 QC - created
#
# Copyright (c) 2005 Novariant Corporation.
# All Rights Reserved. 
##############################################################################
namespace eval Screen { 

    #-------------------------------------------------------------------------
    # Define and pack the screen
    #-------------------------------------------------------------------------
    # All screens must create a top level frame .ftop and destroy it on exit
    frame .ftop

    # Define and pack the screen layout
    # (Screen has custom display and input frames
    # .configDisplay, and .navDisplay components)
    frame .ftop.display         ;# Display Frame
    pack .ftop.display -side top -fill both -expand yes -padx 10


    # Progress bar frame
    frame .ftop.progress
    label .ftop.progress.l1 -text "Progress:"
    pack .ftop.progress.l1 -side top
            
    set barWidth 400
    set barHeight 20
    canvas .ftop.progress.bar -background $color6 \
    	-width $barWidth -height $barHeight -relief sunken -borderwidth 2
    incr barHeight
    .ftop.progress.bar create rectangle 0 0 0 $barHeight \
    	-outline black -fill $colorMedium -tags gauge
    .ftop.progress.bar create text [expr $barWidth/2] 4 \
    	-font $small_font -anchor nw -text "0%" -tags value
    pack .ftop.progress.bar -side top

    # Display Frame - displays up to 5 lines of text
    label .ftop.display.title -text "line 0"

    # pack fields
    # tried to raise progress bar - bar disappeared!
    # pack .ftop.display.title -side top -padx 30 -pady 80 
    # pack .ftop.progress -side top -pady 90
    pack .ftop.display.title -side top -padx 30 -pady 100
    pack .ftop.progress -side top -pady 30

    #-------------------------------------------------------------------------
    # Standard entry and exit procedures (called by GuiMgr)
    #-------------------------------------------------------------------------
    # Action called by GuiMgr on entry to this screen
    proc actEntry { waitText } {
        .ftop.display.title configure -text $waitText
        pack .ftop -fill both -expand yes
    }

    # Action called by GuiMgr on exit from this screen
    proc actExit {} {
        destroy .ftop
    }

    #-------------------------------------------------------------------------
    # Screen action procedures (to be called by GuiMgr)
    #-------------------------------------------------------------------------

    proc actProgress { percentComplete color } {
         .ftop.progress.bar itemconfigure gauge -fill $color
         .ftop.progress.bar itemconfigure value -text "$percentComplete%"
                    
         .ftop.progress.bar coords gauge 1 1 \
             [expr 0.01*$percentComplete*$Screen::barWidth] $Screen::barHeight
    }
                                             
}
