# A5 upgrade script

#!/bin/sh

rm /mnt/sandisk/upgrade/apps/softwareupgrade/upgradeComplete
rm /mnt/sandisk/upgrade/apps/softwareupgrade/upgradeFailed
rm /mnt/sandisk/upgrade/apps/softwareupgrade/systemCorrupted
rm /mnt/sandisk/upgrade/apps/softwareupgrade/backupComplete
rm /mnt/sandisk/upgrade/apps/softwareupgrade/backupFailed


# tar up the database files, and store on the install flash
# first: create mount point and mount the database partition
mount none / -o remount
mkdir -p /configuration/currdir0
mount -t jffs2 /dev/mtdblock4 /configuration/currdir0

# bug fix: get rid of db compare II files; some may be corrupted
/bin/rm /configuration/currdir0/*.ctrlchg

# tar the db files, and unmount
cd /mnt/sandisk/upgrade/backup
tar -cvf currdir0.tar /configuration/currdir0
mkdir /ut
mount -t jffs2 /dev/mtdblock3 /ut
tar -cvf geoid.tar /ut/mmt/apps/geoid
umount /configuration/currdir0
umount /ut

# check that backup was performed successfully
if [ ! -e /mnt/sandisk/upgrade/backup/currdir0.tar  ]; then
   touch /mnt/sandisk/upgrade/apps/softwareupgrade/backupFailed
   touch /mnt/sandisk/upgrade/apps/softwareupgrade/upgradeFailed
   exit
fi

# tar the geoid file (autolevel) if it exists, and save on install flash
mkdir /ut
mount -t jffs2 /dev/mtdblock3 /ut
tar -cvf geoid.tar /ut/mnt/apps/geoid
umount /ut

# install new system
/mnt/sandisk/upgrade/apps/softwareupgrade/freshinstall.sh

#check install performed correctly
if [ ! -e /mnt/sandisk/upgrade/apps/softwareupgrade/installComplete  ]; then
   # install failed.  Restore previous software
   touch /mnt/sandisk/upgrade/apps/softwareupgrade/systemCorrupted
   touch /mnt/sandisk/upgrade/apps/softwareupgrade/upgradeFailed
   exit
fi

#install went ok, so restore database
mount none / -o remount
mkdir -p /configuration/currdir0
mount -t jffs2 /dev/mtdblock4 /configuration/currdir0
cd /
tar -xvf /mnt/sandisk/upgrade/backup/currdir0.tar
echo restored database

# restore geoid file (autolevel)
mount -t jffs2 /dev/mtdblock3 /ut
tar -xvf /mnt/sandisk/upgrade/backup/geoid.tar

# run upgrade software
#mount none / -o remount
cd /configuration/currdir0
/mnt/sandisk/upgrade/apps/vcutils/scripts/upgrade-A5 /ut/mnt/apps
cd /
umount /ut
umount /configuration/currdir0

touch /mnt/sandisk/upgrade/apps/softwareupgrade/upgradeComplete
echo finished!

